
      processor 6502
VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUPF  =  $08
COLUBK  =  $09
REFP1   =  $0C
PF0     =  $0D
PF1     =  $0E
PF2     =  $0F
RESP0   =  $10
RESP1   =  $11
RESM1   =  $13
AUDC0   =  $15
AUDF0   =  $17
AUDV0   =  $19
GRP0    =  $1B
GRP1    =  $1C
ENAM0   =  $1D
ENAM1   =  $1E
HMP0    =  $20
HMP1    =  $21
HMM1    =  $23
VDELP0  =  $25
VDEL01  =  $26
HMOVE   =  $2A
HMCLR   =  $2B
SWCHA   =  $0280
SWCHB   =  $0282
TIM64T  =  $0296
T1024T  =  $0297
LF9F2   =   $F9F2
LFA30   =   $FA30
LFADA   =   $FADA

       ORG $F000

LF000:
       STA    WSYNC                        ;3
       STA    HMOVE                        ;3
       LDA    $D3                          ;3
       STA    ENAM1                        ;3
       ASL                                 ;2
       ASL                                 ;2
       STA    NUSIZ1                       ;3
       LDA    $CD                          ;3
       STA    GRP1                         ;3
       LDA    $CF                          ;3
       STA    ENAM0                        ;3
       DEY                                 ;2
       LDA    ($C4),Y                      ;5
       STA    GRP0                         ;3
       LDA    ($C8),Y                      ;5
       STA    $D3                          ;3
       STA    HMM1                         ;3
       LDA    #$00                         ;2
       STA    $CD                          ;3
       LDA    $E0,X                        ;4
       TAX                                 ;2
       BEQ    LF087                        ;2
       LDA    $BA,X                        ;4
       STA    $F0                          ;3
       LDA    $EE                          ;3
       STA    WSYNC                        ;3
       SEC                                 ;2
       SBC    $BA,X                        ;4
       STA    $C6                          ;3
       LDA    $B5,X                        ;4
       STA    HMP1                         ;3
       AND    #$0F                         ;2

LF03B:
       SBC    #$01                         ;2
       BPL    LF03B                        ;2
       STA    RESP1                        ;3

LF041:
       LDX    $D1                          ;3
       STA    WSYNC                        ;3
       STA    HMOVE                        ;3
       LDA    $D3                          ;3
       STA    ENAM1                        ;3
       ASL                                 ;2
       ASL                                 ;2
       STA    NUSIZ1                       ;3
       LDA    $CD                          ;3
       STA    GRP1                         ;3
       DEY                                 ;2
       LDA    ($C4),Y                      ;5
       STA    GRP0                         ;3
       LDA    ($C6),Y                      ;5
       STA    $CD                          ;3
       STA    HMCLR                        ;3
       LDA    $E1,X                        ;4
       TAX                                 ;2
       BEQ    LF09D                        ;2
       LDA    #$00                         ;2
       STA    $D3                          ;3
       STA    ENAM1                        ;3
       STA    ENAM0                        ;3
       LDA    $BA,X                        ;4
       STA    $F1                          ;3
       LDA    $EF                          ;3
       STA    WSYNC                        ;3
       SEC                                 ;2
       SBC    $BA,X                        ;4
       STA    $C8                          ;3
       LDA    $B5,X                        ;4
       STA    HMM1                         ;3
       AND    #$0F                         ;2

LF07E:
       SBC    #$01                         ;2
       BPL    LF07E                        ;2
       STA    RESM1                        ;3
       JMP    LF1D4                        ;3

LF087:
       STA    WSYNC                        ;3
       LDA    ($C6),Y                      ;5
       STA    $CD                          ;3
       CPY    $F0                          ;3
       BCS    LF09A                        ;2
       STY    $CB                          ;3
       LDA    #$B9                         ;2
       SEC                                 ;2
       SBC    $CB                          ;3
       STA    $C6                          ;3

LF09A:
       JMP    LF041                        ;3

LF09D:
       STA    ENAM0                        ;3
       STA    WSYNC                        ;3
       LDA    ($C8),Y                      ;5
       STA    $D3                          ;3
       STA    HMM1                         ;3
       CPY    $F1                          ;3
       BCS    LF0B4                        ;2
       STY    $CB                          ;3
       LDA    #$B9                         ;2
       SEC                                 ;2
       SBC    $CB                          ;3
       STA    $C8                          ;3

LF0B4:
       JMP    LF1D4                        ;3

LF0B7:
       LDA    $B5                          ;3
       LDX    #$00                         ;2
       JSR    LF894                        ;6
       LDA    #$C0                         ;2
       STA    PF0                          ;3
       LDA    #$FF                         ;2
       STA    PF1                          ;3
       LDA    #$7F                         ;2
       STA    PF2                          ;3
       LDA    #$00                         ;2
       STA    VDEL01                       ;3
       LDA    #$01                         ;2
       STA    VDELP0                       ;3
       LDX    $8B                          ;3
       LDA    LF168,X                      ;4
       STA    COLUP0                       ;3
       LDA    #$9A                         ;2
       STA    COLUP1                       ;3
       LDA    #$30                         ;2
       STA    NUSIZ0                       ;3
       LDA    #$FD                         ;2
       STA    $C9                          ;3
       STA    $C7                          ;3
       LDA    #$FE                         ;2
       STA    $C5                          ;3
       LDA    #$59                         ;2
       STA    $C8                          ;3
       STA    $C6                          ;3
       LDA    $ED                          ;3
       SEC                                 ;2
       SBC    $BA                          ;3
       LDX    $BA                          ;3
       CPX    #$60                         ;2
       BCS    LF0FE                        ;2
       LDA    #$65                         ;2

LF0FE:
       STA    $C4                          ;3
       LDA    #$FF                         ;2
       STA    $F1                          ;3
       STA    $F0                          ;3
       STA    HMCLR                        ;3
       LDX    #$00                         ;2
       STX    $D3                          ;3
       STX    $CD                          ;3
       LDA    $8E                          ;3
       AND    #$40                         ;2
       BNE    LF116                        ;2
       LDX    #$FF                         ;2

LF116:
       STX    $CF                          ;3
       STA    WSYNC                        ;3
       LDX    #$0B                         ;2
       STX    $D1                          ;3
       LDY    #$60                         ;2

LF120:
       LDA    #$00                         ;2
       STA    $D5                          ;3
       STA    $D6                          ;3
       STA    $D7                          ;3
       STA    $D8                          ;3
       STA    $D9                          ;3
       STA    $DA                          ;3
       LDX    $D1                          ;3
       JSR    LF000                        ;6
       JSR    LF16A                        ;6
       JSR    LF1D4                        ;6
       JSR    LF19D                        ;6
       JSR    LF19D                        ;6
       JSR    LF1F4                        ;6
       JSR    LF19D                        ;6
       JSR    LF19D                        ;6
       JSR    LF19D                        ;6
       DEC    $D1                          ;5
       BEQ    LF165                        ;2
       JSR    LF16A                        ;6
       JSR    LF1D4                        ;6
       JSR    LF19D                        ;6
       JSR    LF19D                        ;6
       JSR    LF1F4                        ;6
       STA    WSYNC                        ;3
       DEC    $D1                          ;5
       JMP    LF120                        ;3

LF165:
       JMP    LF2A3                        ;3

LF168:
       .byte $34 ; |  XX X  | $F168
       .byte $C8 ; |XX  X   | $F169

LF16A:
       STA    WSYNC                        ;3
       LDA    #$00                         ;2
       STA    $CF                          ;3
       LDX    $D1                          ;3
       LDA    LFD00,X                      ;4
       STA    PF0                          ;3
       LDA    LFD0D,X                      ;4
       STA    PF1                          ;3
       LDA    LFD1A,X                      ;4
       STA    PF2                          ;3
       STY    $CB                          ;3
       TYA                                 ;2
       SEC                                 ;2
       SBC    $BA                          ;3
       BCC    LF195                        ;2
       CMP    #$0F                         ;2
       BCS    LF195                        ;2
       LDA    $ED                          ;3
       SEC                                 ;2
       SBC    $BA                          ;3
       STA    $C4                          ;3
       RTS                                 ;6

LF195:
       LDA    #$C5                         ;2
       SEC                                 ;2
       SBC    $CB                          ;3
       STA    $C4                          ;3
       RTS                                 ;6

LF19D:
       STA    WSYNC                        ;3
       LDA    $8E                          ;3
       AND    #$10                         ;2
       BEQ    LF1B3                        ;2
       LDA    #$00                         ;2
       CPY    #$37                         ;2
       BCC    LF1B1                        ;2
       CPY    #$3A                         ;2
       BCS    LF1B1                        ;2
       LDA    #$FF                         ;2

LF1B1:
       STA    ENAM0                        ;3

LF1B3:
       LDA    $8E                          ;3
       AND    #$20                         ;2
       BEQ    LF1D4                        ;2
       CPY    #$28                         ;2
       BEQ    LF1CC                        ;2
       CPY    #$26                         ;2
       BNE    LF1D4                        ;2
       LDA    #$00                         ;2
       STA    PF2                          ;3
       LDA    #$94                         ;2
       STA    COLUPF                       ;3
       JMP    LF1D4                        ;3

LF1CC:
       LDA    #$80                         ;2
       STA    PF2                          ;3
       LDA    #$58                         ;2
       STA    COLUPF                       ;3

LF1D4:
       STA    WSYNC                        ;3
       STA    HMOVE                        ;3
       LDA    $D3                          ;3
       STA    ENAM1                        ;3
       ASL                                 ;2
       ASL                                 ;2
       STA    NUSIZ1                       ;3
       LDA    $CD                          ;3
       STA    GRP1                         ;3
       DEY                                 ;2
       LDA    ($C4),Y                      ;5
       STA    GRP0                         ;3
       LDA    ($C6),Y                      ;5
       STA    $CD                          ;3
       LDA    ($C8),Y                      ;5
       STA    $D3                          ;3
       STA    HMM1                         ;3
       RTS                                 ;6

LF1F4:
       STA    WSYNC                        ;3
       LDA    $DB                          ;3
       ASL                                 ;2
       AND    #$0F                         ;2
       CMP    $D1                          ;3
       BNE    LF209                        ;2
       LDA    $DB                          ;3
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAX                                 ;2
       LDA    #$5A                         ;2
       STA    $D4,X                        ;4

LF209:
       LDA    $DC                          ;3
       ASL                                 ;2
       AND    #$0F                         ;2
       CMP    $D1                          ;3
       BNE    LF21C                        ;2
       LDA    $DC                          ;3
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAX                                 ;2
       LDA    #$5A                         ;2
       STA    $D4,X                        ;4

LF21C:
       LDA    $D3                          ;3
       STA    WSYNC                        ;3
       STA    HMOVE                        ;3
       STA    ENAM1                        ;3
       ASL                                 ;2
       ASL                                 ;2
       STA    NUSIZ1                       ;3
       LDA    $CD                          ;3
       STA    GRP1                         ;3
       LDX    $D8                          ;3
       LDA    $D5                          ;3
       STA    COLUBK                       ;3
       LDA    $D6                          ;3
       STA    COLUBK                       ;3
       DEY                                 ;2
       LDA    $D7                          ;3
       STA    COLUBK                       ;3
       LDA    ($C4),Y                      ;5
       STX    COLUBK                       ;3
       LDX    $D9                          ;3
       STX    COLUBK                       ;3
       STA    GRP0                         ;3
       LDX    $DA                          ;3
       STX    COLUBK                       ;3
       LDA    #$00                         ;2
       NOP                                 ;2
       STA    COLUBK                       ;3
       STA    WSYNC                        ;3
       LDX    $D1                          ;3
       LDA    $8F,X                        ;4
       AND    #$AA                         ;2
       STA    PF2                          ;3
       EOR    $8F,X                        ;4
       STA    PF1                          ;3
       NOP                                 ;2
       NOP                                 ;2
       LDA    #$2C                         ;2
       STA    COLUPF                       ;3
       LDA    ($C8),Y                      ;5
       STA    $D3                          ;3
       STA    HMM1                         ;3
       LDA    $9B,X                        ;4
       AND    #$AA                         ;2
       STA    PF2                          ;3
       EOR    $9B,X                        ;4
       STA    PF1                          ;3
       LDA    ($C6),Y                      ;5
       STA    $CD                          ;3
       NOP                                 ;2
       LDA    #$94                         ;2
       STA    COLUPF                       ;3
       LDA    $D3                          ;3
       STA    ENAM1                        ;3
       STA    HMOVE                        ;3
       ASL                                 ;2
       ASL                                 ;2
       STA    NUSIZ1                       ;3
       LDA    $CD                          ;3
       STA    GRP1                         ;3
       LDA    LFD0D,X                      ;4
       STA    PF1                          ;3
       LDA    LFD1A,X                      ;4
       STA    PF2                          ;3
       DEY                                 ;2
       LDA    ($C4),Y                      ;5
       STA    GRP0                         ;3
       LDA    ($C6),Y                      ;5
       STA    $CD                          ;3
       LDA    ($C8),Y                      ;5
       STA    $D3                          ;3
       STA    HMM1                         ;3
       RTS                                 ;6

LF2A3:
       STA    WSYNC                        ;3
       LDA    #$00                         ;2
       STA    GRP0                         ;3
       STA    GRP1                         ;3
       STA    ENAM1                        ;3
       LDA    #$03                         ;2
       STA    NUSIZ0                       ;3
       STA    NUSIZ1                       ;3
       LDA    #$01                         ;2
       STA    VDELP0                       ;3
       STA    VDEL01                       ;3
       LDA    #$00                         ;2
       STA    GRP0                         ;3
       LDX    #$D0                         ;2
       LDA    #$E0                         ;2
       STA    RESP0                        ;3
       STA    RESP1                        ;3
       STA    HMP1                         ;3
       STX    HMP0                         ;3
       LDA    #$FE                         ;2
       STA    $CB                          ;3
       STA    $D1                          ;3
       STA    $CD                          ;3
       STA    $D3                          ;3
       STA    $CF                          ;3
       STA    $D5                          ;3
       STA    WSYNC                        ;3
       STA    HMOVE                        ;3
       LDA    #$FF                         ;2
       STA    PF1                          ;3
       STA    PF2                          ;3
       LDX    $8B                          ;3
       LDA    LF347,X                      ;4
       STA    COLUP0                       ;3
       STA    COLUP1                       ;3
       LDA    $8E                          ;3
       AND    #$02                         ;2
       BNE    LF2F4                        ;2
       LDA    #$CC                         ;2
       STA    COLUP0                       ;3

LF2F4:
       LDA    $AF                          ;3
       BNE    LF2FC                        ;2
       LDA    $88,X                        ;4
       BNE    LF309                        ;2

LF2FC:
       LDA    $AD                          ;3
       AND    #$08                         ;2
       BEQ    LF309                        ;2
       LDA    LF349,X                      ;4
       STA    COLUP0                       ;3
       STA    COLUP1                       ;3

LF309:
       LDY    #$06                         ;2

LF30B:
       STY    $D7                          ;3
       LDA    ($D4),Y                      ;5
       TAX                                 ;2
       STA    WSYNC                        ;3
       LDA    ($CE),Y                      ;5
       STA    $D6                          ;3
       LDA    ($CA),Y                      ;5
       STA    GRP0                         ;3
       LDA    ($D0),Y                      ;5
       STA    GRP1                         ;3
       LDA    ($CC),Y                      ;5
       STA    GRP0                         ;3
       LDA    ($D2),Y                      ;5
       TAY                                 ;2
       LDA    $D6                          ;3
       STY    GRP1                         ;3
       STA    GRP0                         ;3
       STX    GRP1                         ;3
       STA    GRP0                         ;3
       LDY    $D7                          ;3
       DEY                                 ;2
       BPL    LF30B                        ;2
       STA    WSYNC                        ;3
       LDA    #$00                         ;2
       STA    GRP0                         ;3
       STA    GRP1                         ;3
       STA    GRP0                         ;3
       STA    WSYNC                        ;3
       STA    PF0                          ;3
       STA    PF1                          ;3
       STA    PF2                          ;3
       RTS                                 ;6

LF347:
       .byte $3C ; |  XXXX  | $F347
       .byte $CC ; |XX  XX  | $F348

LF349:
       .byte $08 ; |    X   | $F349
       .byte $08 ; |    X   | $F34A

LF34B:
       LDY    $8A                          ;3
       BNE    LF353                        ;2


START:
       SEI                                 ;2
       CLD                                 ;2
       LDY    #$00                         ;2

LF353:
       LDA    #$00                         ;2
       TAX                                 ;2

LF356:
       STA    VSYNC,X                      ;4
       DEX                                 ;2
       BNE    LF356                        ;2
       STY    $8A                          ;3
       LDA    #$05                         ;2
       STA    $88                          ;3
       STA    $89                          ;3
       JMP    LF39B                        ;3

LF366:
       JSR    LF4EE                        ;6
       LDA    #$EE                         ;2
       STA    TIM64T                       ;4
       LDX    #$80                         ;2
       LDA    #$00                         ;2

LF372:
       DEX                                 ;2
       STA    VSYNC,X                      ;4
       CPX    #$AB                         ;2
       BNE    LF372                        ;2
       LDX    $8B                          ;3
       LDA    $88,X                        ;4
       BEQ    LF385                        ;2
       LDA    $8E                          ;3
       AND    #$01                         ;2
       BEQ    LF38B                        ;2

LF385:
       LDA    $8A                          ;3
       EOR    $8B                          ;3
       STA    $8B                          ;3

LF38B:
       LDX    $8B                          ;3
       LDA    #$0A                         ;2
       LDY    $88,X                        ;4
       BNE    LF399                        ;2
       LDA    #$B4                         ;2
       STA    $AE                          ;3
       LDA    #$06                         ;2

LF399:
       STA    $8E                          ;3

LF39B:
       LDY    #$16                         ;2

LF39D:
       LDX    LF3E6,Y                      ;4
       LDA    LF3FC,Y                      ;4
       STA    $80,X                        ;4
       DEY                                 ;2
       BNE    LF39D                        ;2
       LDA    $A8                          ;3
       ORA    #$40                         ;2
       STA    $A8                          ;3
       LDA    $8A                          ;3
       BNE    LF3B6                        ;2
       LDA    $8F                          ;3
       BNE    LF3CE                        ;2

LF3B6:
       LDX    #$0B                         ;2

LF3B8:
       LDA    LF3DB,X                      ;4
       STA    $8F,X                        ;4
       STA    $9B,X                        ;4
       DEX                                 ;2
       BPL    LF3B8                        ;2
       LDA    #$04                         ;2
       STA    $9B                          ;3
       LDA    #$00                         ;2
       STA    $A9                          ;3
       LDA    #$68                         ;2
       STA    $8F                          ;3

LF3CE:
       LDX    #$FF                         ;2
       TXS                                 ;2
       LDA    #$B4                         ;2
       LDX    #$02                         ;2
       JSR    LF894                        ;6
       JMP    LF413                        ;3

LF3DB:
       .byte $00 ; |        | $F3DB
       .byte $7F ; | XXXXXXX| $F3DC
       .byte $61 ; | XX    X| $F3DD
       .byte $6B ; | XX X XX| $F3DE
       .byte $61 ; | XX    X| $F3DF
       .byte $7F ; | XXXXXXX| $F3E0
       .byte $61 ; | XX    X| $F3E1
       .byte $75 ; | XXX X X| $F3E2
       .byte $61 ; | XX    X| $F3E3
       .byte $7F ; | XXXXXXX| $F3E4
       .byte $60 ; | XX     | $F3E5

LF3E6:
       .byte $7F ; | XXXXXXX| $F3E6
       .byte $30 ; |  XX    | $F3E7
       .byte $31 ; |  XX   X| $F3E8
       .byte $32 ; |  XX  X | $F3E9
       .byte $33 ; |  XX  XX| $F3EA
       .byte $34 ; |  XX X  | $F3EB
       .byte $35 ; |  XX X X| $F3EC
       .byte $36 ; |  XX XX | $F3ED
       .byte $37 ; |  XX XXX| $F3EE
       .byte $38 ; |  XXX   | $F3EF
       .byte $39 ; |  XXX  X| $F3F0
       .byte $3A ; |  XXX X | $F3F1
       .byte $3B ; |  XXX XX| $F3F2
       .byte $3C ; |  XXXX  | $F3F3
       .byte $3D ; |  XXXX X| $F3F4
       .byte $3E ; |  XXXXX | $F3F5
       .byte $40 ; | X      | $F3F6
       .byte $41 ; | X     X| $F3F7
       .byte $42 ; | X    X | $F3F8
       .byte $43 ; | X    XX| $F3F9
       .byte $A5 ; |X X  X X| $F3FA
       .byte $8A ; |X   X X | $F3FB

LF3FC:
       .byte $2A ; |  X X X | $F3FC
       .byte $4A ; | X  X X | $F3FD
       .byte $08 ; |    X   | $F3FE
       .byte $8C ; |X   XX  | $F3FF
       .byte $08 ; |    X   | $F400
       .byte $8C ; |X   XX  | $F401
       .byte $C4 ; |XX   X  | $F402
       .byte $10 ; |   X    | $F403
       .byte $69 ; | XX X  X| $F404
       .byte $10 ; |   X    | $F405
       .byte $69 ; | XX X  X| $F406
       .byte $62 ; | XX   X | $F407
       .byte $28 ; |  X X   | $F408
       .byte $28 ; |  X X   | $F409
       .byte $38 ; |  XXX   | $F40A
       .byte $38 ; |  XXX   | $F40B
       .byte $80 ; |X       | $F40C
       .byte $40 ; | X      | $F40D
       .byte $80 ; |X       | $F40E
       .byte $40 ; | X      | $F40F
       .byte $05 ; |     X X| $F410
       .byte $01 ; |       X| $F411
       .byte $02 ; |      X | $F412

LF413:
       JSR    LF4EE                        ;6
       LDA    #$02                         ;2
       STA    VBLANK                       ;3
       LDA    #$19                         ;2
       STA    TIM64T                       ;4
       LDA    $AE                          ;3
       BEQ    LF425                        ;2
       DEC    $AE                          ;5

LF425:
       JSR    LF650                        ;6
       DEC    $AD                          ;5
       JSR    LFCF3                        ;6
       JSR    LF75F                        ;6
       JSR    LF5DE                        ;6
       JSR    LF998                        ;6
       JSR    LF571                        ;6
       JSR    LF4EE                        ;6
       LDA    #$2D                         ;2
       STA    TIM64T                       ;4
       LDA    #$02                         ;2
       STA    VSYNC                        ;3
       STA    WSYNC                        ;3
       STA    WSYNC                        ;3
       STA    WSYNC                        ;3
       LDA    #$00                         ;2
       STA    VSYNC                        ;3
       LDA    $8E                          ;3
       AND    #$02                         ;2
       BNE    LF475                        ;2
       LDY    #$80                         ;2
       LDA    SWCHB                        ;4
       ASL                                 ;2
       BCC    LF45F                        ;2
       STY    $87                          ;3

LF45F:
       ASL                                 ;2
       BCC    LF464                        ;2
       STY    $86                          ;3

LF464:
       LDA    REFP1                        ;3
       AND    PF0                          ;3
       BMI    LF4D4                        ;2
       LDA    #$0A                         ;2
       STA    $8E                          ;3
       LDA    #$1E                         ;2
       STA    $AE                          ;3
       JMP    LF4D4                        ;3

LF475:
       LDA    $8E                          ;3
       AND    #$04                         ;2
       BEQ    LF49E                        ;2
       LDA    $AE                          ;3
       BNE    LF4D4                        ;2
       LDA    $8A                          ;3
       ORA    $88                          ;3
       BEQ    LF4D4                        ;2
       LDA    $88                          ;3
       ORA    $89                          ;3
       BEQ    LF49B                        ;2
       LDA    $8E                          ;3
       AND    #$01                         ;2
       LDX    $8B                          ;3
       ORA    $88,X                        ;4
       BEQ    LF49B                        ;2
       LDA    REFP1                        ;3
       AND    PF0                          ;3
       BMI    LF4D4                        ;2

LF49B:
       JMP    LF366                        ;3

LF49E:
       LDA    $8E                          ;3
       AND    #$08                         ;2
       BEQ    LF4B9                        ;2
       LDA    #$58                         ;2
       STA    $BA                          ;3
       LDA    REFP1                        ;3
       AND    PF0                          ;3
       BPL    LF4D4                        ;2
       LDA    SWCHA                        ;4
       CMP    #$FF                         ;2
       BEQ    LF4D4                        ;2
       LDA    #$02                         ;2
       STA    $8E                          ;3

LF4B9:
       LDA    $AD                          ;3
       AND    #$01                         ;2
       BNE    LF4D1                        ;2
       JSR    LFCA8                        ;6
       JSR    LFC22                        ;6
       JSR    LF835                        ;6
       JSR    LF4FC                        ;6
       JSR    LF8AB                        ;6
       JMP    LF4D4                        ;3

LF4D1:
       JSR    LFAC5                        ;6

LF4D4:
       JSR    LF965                        ;6
       JSR    LF93D                        ;6
       JSR    LF4EE                        ;6
       LDA    #$00                         ;2
       STA    VBLANK                       ;3
       LDA    #$EE                         ;2
       STA    TIM64T                       ;4
       STA    WSYNC                        ;3
       JSR    LF0B7                        ;6
       JMP    LF413                        ;3

LF4EE:
       LDA    T1024T                       ;4
       BPL    LF4F4                        ;2
       NOP                                 ;2

LF4F4:
       STA    WSYNC                        ;3
       LDA    T1024T                       ;4
       BPL    LF4F4                        ;2
       RTS                                 ;6

LF4FC:
       LDA    $8E                          ;3
       AND    #$04                         ;2
       BNE    LF570                        ;2
       LDX    #$04                         ;2

LF504:
       LDA    $B0                          ;3
       CMP    $B0,X                        ;4
       BNE    LF514                        ;2
       LDA    $BA                          ;3
       SBC    $BA,X                        ;4
       ADC    #$04                         ;2
       CMP    #$0C                         ;2
       BCC    LF542                        ;2

LF514:
       LDA    $BA                          ;3
       CMP    $BA,X                        ;4
       BNE    LF524                        ;2
       LDA    $B0                          ;3
       SBC    $B0,X                        ;4
       ADC    #$05                         ;2
       CMP    #$0C                         ;2
       BCC    LF542                        ;2

LF524:
       DEX                                 ;2
       BNE    LF504                        ;2
       LDA    $8F                          ;3
       BNE    LF570                        ;2
       LDA    $BA                          ;3
       CMP    #$5F                         ;2
       BEQ    LF538                        ;2
       LDA    $8E                          ;3
       ORA    #$40                         ;2
       STA    $8E                          ;3
       RTS                                 ;6

LF538:
       LDA    #$08                         ;2
       JSR    LF5BC                        ;6
       LDA    #$06                         ;2
       JMP    LF550                        ;3

LF542:
       LDA    #$07                         ;2
       JSR    LF5BC                        ;6
       LDX    $8B                          ;3
       LDY    $88,X                        ;4
       DEY                                 ;2
       STY    $88,X                        ;4
       LDA    #$07                         ;2

LF550:
       ORA    $8E                          ;3
       AND    #$BF                         ;2
       STA    $8E                          ;3
       LDA    #$1E                         ;2
       LDX    $8B                          ;3
       LDY    $88                          ;3
       BNE    LF560                        ;2
       LDA    #$B4                         ;2

LF560:
       STA    $AE                          ;3
       LDA    $8C,X                        ;4
       SEC                                 ;2
       SBC    #$68                         ;2
       BCC    LF570                        ;2
       STA    $8C,X                        ;4
       LDY    $86,X                        ;4
       INY                                 ;2
       STY    $86,X                        ;4

LF570:
       RTS                                 ;6

LF571:
       LDA    SWCHB                        ;4
       LSR                                 ;2
       BCS    LF57A                        ;2
       JMP    LF34B                        ;3

LF57A:
       LDA    $8E                          ;3
       AND    #$02                         ;2
       BNE    LF597                        ;2
       LDA    SWCHB                        ;4
       LSR                                 ;2
       LSR                                 ;2
       BCS    LF597                        ;2
       LDA    $AE                          ;3
       CMP    #$05                         ;2
       BCS    LF593                        ;2
       LDA    $8A                          ;3
       EOR    #$01                         ;2
       STA    $8A                          ;3

LF593:
       LDA    #$0A                         ;2
       STA    $AE                          ;3

LF597:
       RTS                                 ;6

LF598:
       .byte $00 ; |        | $F598
       .byte $05 ; |     X X| $F599
       .byte $0F ; |    XXXX| $F59A
       .byte $06 ; |     XX | $F59B
       .byte $00 ; |        | $F59C
       .byte $00 ; |        | $F59D
       .byte $0F ; |    XXXX| $F59E
       .byte $0F ; |    XXXX| $F59F
       .byte $06 ; |     XX | $F5A0

LF5A1:
       .byte $00 ; |        | $F5A1
       .byte $01 ; |       X| $F5A2
       .byte $02 ; |      X | $F5A3
       .byte $1F ; |   XXXXX| $F5A4
       .byte $08 ; |    X   | $F5A5
       .byte $08 ; |    X   | $F5A6
       .byte $1F ; |   XXXXX| $F5A7
       .byte $06 ; |     XX | $F5A8
       .byte $1F ; |   XXXXX| $F5A9

LF5AA:
       .byte $00 ; |        | $F5AA
       .byte $01 ; |       X| $F5AB
       .byte $02 ; |      X | $F5AC
       .byte $0C ; |    XX  | $F5AD
       .byte $0C ; |    XX  | $F5AE
       .byte $0C ; |    XX  | $F5AF
       .byte $04 ; |     X  | $F5B0
       .byte $08 ; |    X   | $F5B1
       .byte $04 ; |     X  | $F5B2

LF5B3:
       .byte $00 ; |        | $F5B3
       .byte $05 ; |     X X| $F5B4
       .byte $03 ; |      XX| $F5B5
       .byte $FF ; |XXXXXXXX| $F5B6
       .byte $60 ; | XX     | $F5B7
       .byte $6F ; | XX XXXX| $F5B8
       .byte $6F ; | XX XXXX| $F5B9
       .byte $38 ; |  XXX   | $F5BA
       .byte $60 ; | XX     | $F5BB

LF5BC:
       LDX    #$01                         ;2

LF5BE:
       CMP    $F5,X                        ;4
       BCC    LF5DA                        ;2
       TAY                                 ;2
       STY    $F5,X                        ;4
       LDA    LF598,Y                      ;4
       STA    AUDV0,X                      ;4
       LDA    LF5A1,Y                      ;4
       STA    AUDF0,X                      ;4
       LDA    LF5AA,Y                      ;4
       STA    AUDC0,X                      ;4
       LDA    LF5B3,Y                      ;4
       STA    $F3,X                        ;4
       RTS                                 ;6

LF5DA:
       DEX                                 ;2
       BPL    LF5BE                        ;2
       RTS                                 ;6

LF5DE:
       LDX    #$01                         ;2

LF5E0:
       LDY    $F3,X                        ;4
       BEQ    LF647                        ;2
       DEY                                 ;2
       STY    $F3,X                        ;4
       TYA                                 ;2
       LDY    $F5,X                        ;4
       CPY    #$02                         ;2
       BNE    LF5F2                        ;2
       ASL                                 ;2
       ASL                                 ;2
       STA    AUDV0,X                      ;4

LF5F2:
       CPY    #$04                         ;2
       BNE    LF5FA                        ;2
       AND    #$0F                         ;2
       STA    AUDV0,X                      ;4

LF5FA:
       CPY    #$05                         ;2
       BNE    LF603                        ;2
       ASL                                 ;2
       AND    #$08                         ;2
       STA    AUDV0,X                      ;4

LF603:
       CPY    #$07                         ;2
       BNE    LF60B                        ;2
       LSR                                 ;2
       LSR                                 ;2
       STA    AUDV0,X                      ;4

LF60B:
       CPY    #$01                         ;2
       BNE    LF611                        ;2
       STA    AUDV0,X                      ;4

LF611:
       CPY    #$08                         ;2
       BNE    LF619                        ;2
       AND    #$1F                         ;2
       STA    AUDF0,X                      ;4

LF619:
       CPY    #$03                         ;2
       BNE    LF63A                        ;2
       LSR                                 ;2
       LSR                                 ;2
       AND    #$0F                         ;2
       TAY                                 ;2
       LDA    LF62A,Y                      ;4
       STA    AUDF0,X                      ;4
       JMP    LF643                        ;3

LF62A:
       .byte $08 ; |    X   | $F62A
       .byte $09 ; |    X  X| $F62B
       .byte $0A ; |    X X | $F62C
       .byte $0B ; |    X XX| $F62D
       .byte $0C ; |    XX  | $F62E
       .byte $0D ; |    XX X| $F62F
       .byte $0E ; |    XXX | $F630
       .byte $0F ; |    XXXX| $F631
       .byte $10 ; |   X    | $F632
       .byte $0F ; |    XXXX| $F633
       .byte $0E ; |    XXX | $F634
       .byte $0D ; |    XX X| $F635
       .byte $0C ; |    XX  | $F636
       .byte $0B ; |    X XX| $F637
       .byte $0A ; |    X X | $F638
       .byte $09 ; |    X  X| $F639

LF63A:
       CPY    #$06                         ;2
       BNE    LF643                        ;2
       LSR                                 ;2
       AND    #$1F                         ;2
       STA    AUDF0,X                      ;4

LF643:
       DEX                                 ;2
       BPL    LF5E0                        ;2
       RTS                                 ;6

LF647:
       STY    AUDC0,X                      ;4
       STY    AUDV0,X                      ;4
       STY    $F5,X                        ;4
       JMP    LF643                        ;3

LF650:
       LDA    $8E                          ;3
       AND    #$08                         ;2
       BNE    LF6A8                        ;2
       LDA    $8E                          ;3
       AND    #$02                         ;2
       BEQ    LF6B3                        ;2
       LDX    $AF                          ;3
       BEQ    LF664                        ;2
       DEX                                 ;2
       STX    $AF                          ;3

LF663:
       RTS                                 ;6

LF664:
       LDX    $8B                          ;3
       LDA    $84,X                        ;4
       BEQ    LF687                        ;2
       AND    #$01                         ;2
       BNE    LF687                        ;2
       LDY    $AB                          ;3
       BEQ    LF68B                        ;2
       LDY    $88,X                        ;4
       INY                                 ;2
       CPY    #$07                         ;2
       BCS    LF67B                        ;2
       STY    $88,X                        ;4

LF67B:
       LDA    #$00                         ;2
       STA    $AB                          ;3
       LDA    #$04                         ;2
       JSR    LF5BC                        ;6
       JMP    LF68B                        ;3

LF687:
       LDA    #$01                         ;2
       STA    $AB                          ;3

LF68B:
       LDX    $8B                          ;3
       LDY    #$04                         ;2

LF68F:
       LDA    $80,X                        ;4
       AND    #$0F                         ;2
       ASL                                 ;2
       ASL                                 ;2
       ASL                                 ;2
       STA.wy $00D0,Y                      ;5
       LDA    $80,X                        ;4
       AND    #$F0                         ;2
       LSR                                 ;2
       STA.wy $00CA,Y                      ;5
       INX                                 ;2
       INX                                 ;2
       DEY                                 ;2
       DEY                                 ;2
       BPL    LF68F                        ;2
       RTS                                 ;6

LF6A8:
       LDX    $8B                          ;3
       LDY    $88,X                        ;4
       LDX    LF707,Y                      ;4
       LDY    #$0A                         ;2
       BNE    LF6F5                        ;2

LF6B3:
       LDY    $8A                          ;3
       LDX    LF70E,Y                      ;4
       LDY    #$0A                         ;2
       BNE    LF6F5                        ;2

LF6BC:
       SED                                 ;2
       CLC                                 ;2
       LDA    LF6E0,Y                      ;4
       LDX    $8B                          ;3
       ADC    $80,X                        ;4
       STA    $80,X                        ;4
       LDA    LF6E6,Y                      ;4
       ADC    $82,X                        ;4
       STA    $82,X                        ;4
       LDA    #$00                         ;2
       ADC    $84,X                        ;4
       STA    $84,X                        ;4
       CLD                                 ;2
       BCC    LF663                        ;2
       LDA    #$99                         ;2
       STA    $80,X                        ;4
       STA    $82,X                        ;4
       STA    $84,X                        ;4
       RTS                                 ;6

LF6E0:
       .byte $50 ; | X X    | $F6E0
       .byte $00 ; |        | $F6E1
       .byte $00 ; |        | $F6E2
       .byte $00 ; |        | $F6E3
       .byte $00 ; |        | $F6E4
       .byte $20 ; |  X     | $F6E5

LF6E6:
       .byte $02 ; |      X | $F6E6
       .byte $05 ; |     X X| $F6E7
       .byte $10 ; |   X    | $F6E8
       .byte $20 ; |  X     | $F6E9
       .byte $40 ; | X      | $F6EA
       .byte $00 ; |        | $F6EB

LF6EC:
       LDA    #$78                         ;2
       STA    $AF                          ;3
       LDX    LF701,Y                      ;4
       LDY    #$0A                         ;2

LF6F5:
       LDA    LF710,X                      ;4
       STA.wy $00CA,Y                      ;5
       DEX                                 ;2
       DEY                                 ;2
       DEY                                 ;2
       BPL    LF6F5                        ;2
       RTS                                 ;6

LF701:
       .byte $1D ; |   XXX X| $F701
       .byte $05 ; |     X X| $F702
       .byte $0B ; |    X XX| $F703
       .byte $11 ; |   X   X| $F704
       .byte $17 ; |   X XXX| $F705
       .byte $1D ; |   XXX X| $F706

LF707:
       .byte $00 ; |        | $F707
       .byte $23 ; |  X   XX| $F708
       .byte $29 ; |  X X  X| $F709
       .byte $2F ; |  X XXXX| $F70A
       .byte $35 ; |  XX X X| $F70B
       .byte $3B ; |  XXX XX| $F70C
       .byte $41 ; | X     X| $F70D

LF70E:
       .byte $47 ; | X   XXX| $F70E
       .byte $4D ; | X  XX X| $F70F

LF710:
       .byte $50 ; | X X    | $F710
       .byte $28 ; |  X X   | $F711
       .byte $00 ; |        | $F712
       .byte $58 ; | X XX   | $F713
       .byte $00 ; |        | $F714
       .byte $50 ; | X X    | $F715
       .byte $58 ; | X XX   | $F716
       .byte $00 ; |        | $F717
       .byte $00 ; |        | $F718
       .byte $08 ; |    X   | $F719
       .byte $00 ; |        | $F71A
       .byte $50 ; | X X    | $F71B
       .byte $58 ; | X XX   | $F71C
       .byte $00 ; |        | $F71D
       .byte $00 ; |        | $F71E
       .byte $10 ; |   X    | $F71F
       .byte $00 ; |        | $F720
       .byte $50 ; | X X    | $F721
       .byte $58 ; | X XX   | $F722
       .byte $00 ; |        | $F723
       .byte $00 ; |        | $F724
       .byte $20 ; |  X     | $F725
       .byte $00 ; |        | $F726
       .byte $50 ; | X X    | $F727
       .byte $50 ; | X X    | $F728
       .byte $10 ; |   X    | $F729
       .byte $00 ; |        | $F72A
       .byte $58 ; | X XX   | $F72B
       .byte $28 ; |  X X   | $F72C
       .byte $50 ; | X X    | $F72D
       .byte $50 ; | X X    | $F72E
       .byte $50 ; | X X    | $F72F
       .byte $50 ; | X X    | $F730
       .byte $50 ; | X X    | $F731
       .byte $50 ; | X X    | $F732
       .byte $50 ; | X X    | $F733
       .byte $50 ; | X X    | $F734
       .byte $50 ; | X X    | $F735
       .byte $60 ; | XX     | $F736
       .byte $50 ; | X X    | $F737
       .byte $50 ; | X X    | $F738
       .byte $50 ; | X X    | $F739
       .byte $50 ; | X X    | $F73A
       .byte $50 ; | X X    | $F73B
       .byte $60 ; | XX     | $F73C
       .byte $50 ; | X X    | $F73D
       .byte $60 ; | XX     | $F73E
       .byte $50 ; | X X    | $F73F
       .byte $50 ; | X X    | $F740
       .byte $60 ; | XX     | $F741
       .byte $60 ; | XX     | $F742
       .byte $50 ; | X X    | $F743
       .byte $60 ; | XX     | $F744
       .byte $50 ; | X X    | $F745
       .byte $50 ; | X X    | $F746
       .byte $60 ; | XX     | $F747
       .byte $60 ; | XX     | $F748
       .byte $60 ; | XX     | $F749
       .byte $60 ; | XX     | $F74A
       .byte $50 ; | X X    | $F74B
       .byte $50 ; | X X    | $F74C
       .byte $60 ; | XX     | $F74D
       .byte $60 ; | XX     | $F74E
       .byte $60 ; | XX     | $F74F
       .byte $60 ; | XX     | $F750
       .byte $60 ; | XX     | $F751
       .byte $50 ; | X X    | $F752
       .byte $50 ; | X X    | $F753
       .byte $50 ; | X X    | $F754
       .byte $50 ; | X X    | $F755
       .byte $50 ; | X X    | $F756
       .byte $50 ; | X X    | $F757
       .byte $50 ; | X X    | $F758
       .byte $50 ; | X X    | $F759
       .byte $60 ; | XX     | $F75A
       .byte $60 ; | XX     | $F75B
       .byte $50 ; | X X    | $F75C
       .byte $50 ; | X X    | $F75D

LF75E:
       RTS                                 ;6

LF75F:
       LDA    $AF                          ;3
       BNE    LF75E                        ;2
       LDX    $8B                          ;3
       LDA    $86,X                        ;4
       AND    #$0F                         ;2
       CMP    #$04                         ;2
       BCC    LF76F                        ;2
       LDA    #$04                         ;2

LF76F:
       STA    $CF                          ;3
       LDX    #$01                         ;2
       LDA    $8E                          ;3
       AND    LF831,X                      ;4
       BNE    LF7DB                        ;2
       LDY    $9B                          ;3
       LDA    $8F                          ;3
       CMP    LF82A,Y                      ;4
       BCS    LF7D4                        ;2
       LDA    #$03                         ;2
       JSR    LF5BC                        ;6
       DEC    $9B                          ;5
       JMP    LF7B5                        ;3

LF78D:
       LDA    $8E                          ;3
       AND    LF831,X                      ;4
       BNE    LF7DB                        ;2
       LDA    $8E                          ;3
       BEQ    LF7D4                        ;2
       AND    #$0C                         ;2
       BNE    LF7D4                        ;2
       LDA    $BA                          ;3
       CMP    #$28                         ;2
       BEQ    LF7D7                        ;2
       LDA    $AD                          ;3
       AND    #$03                         ;2
       BNE    LF7D7                        ;2
       LDY    $A7,X                        ;4
       DEY                                 ;2
       STY    $A7,X                        ;4
       BNE    LF7D7                        ;2
       LDA    $AA                          ;3
       BEQ    LF7D7                        ;2
       DEC    $AA                          ;5

LF7B5:
       LDA    $8E                          ;3
       ORA    LF831,X                      ;4
       STA    $8E                          ;3
       LDA    #$FF                         ;2
       STA    $A7,X                        ;4
       LDY    LF833,X                      ;4
       LDA.wy $008F,Y                      ;4
       ORA    #$80                         ;2
       STA.wy $008F,Y                      ;5
       LDA.wy $009B,Y                      ;4
       ORA    #$80                         ;2
       STA.wy $009B,Y                      ;5
       RTS                                 ;6

LF7D4:
       JSR    LF816                        ;6

LF7D7:
       DEX                                 ;2
       BPL    LF78D                        ;2
       RTS                                 ;6

LF7DB:
       LDA    $BA                          ;3
       CMP    LF82F,X                      ;4
       BNE    LF804                        ;2
       LDA    $B0                          ;3
       CMP    #$4A                         ;2
       BNE    LF804                        ;2
       STX    $D3                          ;3
       LDY    $CF                          ;3
       TXA                                 ;2
       BEQ    LF7F4                        ;2
       LDY    $A9                          ;3
       INY                                 ;2
       STY    $A9                          ;3

LF7F4:
       JSR    LF6BC                        ;6
       JSR    LF6EC                        ;6
       LDA    #$06                         ;2
       JSR    LF5BC                        ;6
       LDX    $D3                          ;3
       JMP    LF80B                        ;3

LF804:
       LDY    $A7,X                        ;4
       DEY                                 ;2
       STY    $A7,X                        ;4
       BNE    LF7D7                        ;2

LF80B:
       LDA    $8E                          ;3
       EOR    LF831,X                      ;4
       STA    $8E                          ;3
       LDA    #$FF                         ;2
       STA    $A7,X                        ;4

LF816:
       LDY    LF833,X                      ;4
       LDA.wy $008F,Y                      ;4
       AND    #$7F                         ;2
       STA.wy $008F,Y                      ;5
       LDA.wy $009B,Y                      ;4
       AND    #$7F                         ;2
       STA.wy $009B,Y                      ;5
       RTS                                 ;6

LF82A:
       .byte $00 ; |        | $F82A
       .byte $05 ; |     X X| $F82B
       .byte $19 ; |   XX  X| $F82C
       .byte $37 ; |  XX XXX| $F82D
       .byte $59 ; | X XX  X| $F82E

LF82F:
       .byte $28 ; |  X X   | $F82F
       .byte $38 ; |  XXX   | $F830

LF831:
       .byte $20 ; |  X     | $F831
       .byte $10 ; |   X    | $F832

LF833:
       .byte $05 ; |     X X| $F833
       .byte $07 ; |     XXX| $F834

LF835:
       LDA    $BA                          ;3
       AND    #$07                         ;2
       BNE    LF883                        ;2
       LDA    $BA                          ;3
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAX                                 ;2
       LDA    $B0                          ;3
       SEC                                 ;2
       SBC    #$0C                         ;2
       BCC    LF883                        ;2
       CMP    #$79                         ;2
       BCS    LF883                        ;2
       CMP    #$3C                         ;2
       BCC    LF852                        ;2
       ADC    #$03                         ;2

LF852:
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAY                                 ;2
       LDA    LF884,Y                      ;4
       CPY    #$08                         ;2
       BCS    LF868                        ;2
       AND    $8F,X                        ;4
       BEQ    LF883                        ;2
       EOR    $8F,X                        ;4
       STA    $8F,X                        ;4
       JMP    LF870                        ;3

LF868:
       AND    $9B,X                        ;4
       BEQ    LF883                        ;2
       EOR    $9B,X                        ;4
       STA    $9B,X                        ;4

LF870:
       LDA    #$01                         ;2
       JSR    LF5BC                        ;6
       LDY    #$05                         ;2
       JSR    LF6BC                        ;6
       DEC    $8F                          ;5
       LDX    $8B                          ;3
       LDY    $8C,X                        ;4
       INY                                 ;2
       STY    $8C,X                        ;4

LF883:
       RTS                                 ;6

LF884:
       .byte $40 ; | X      | $F884
       .byte $10 ; |   X    | $F885
       .byte $04 ; |     X  | $F886
       .byte $01 ; |       X| $F887
       .byte $02 ; |      X | $F888
       .byte $08 ; |    X   | $F889
       .byte $20 ; |  X     | $F88A
       .byte $00 ; |        | $F88B
       .byte $00 ; |        | $F88C
       .byte $20 ; |  X     | $F88D
       .byte $08 ; |    X   | $F88E
       .byte $02 ; |      X | $F88F
       .byte $01 ; |       X| $F890
       .byte $04 ; |     X  | $F891
       .byte $10 ; |   X    | $F892
       .byte $40 ; | X      | $F893

LF894:
       STA    WSYNC                        ;3
       STA    HMCLR                        ;3
       STA    HMP0,X                       ;4
       AND    #$0F                         ;2
       NOP                                 ;2
       NOP                                 ;2
       NOP                                 ;2
       SEC                                 ;2

LF8A0:
       SBC    #$01                         ;2
       BPL    LF8A0                        ;2
       STA    RESP0,X                      ;4
       STA    WSYNC                        ;3
       STA    HMOVE                        ;3
       RTS                                 ;6

LF8AB:
       LDA    $AF                          ;3
       BNE    LF91F                        ;2
       LDX    #$00                         ;2
       JSR    LFA6C                        ;6
       STA    $D3                          ;3
       LDA    $DB                          ;3
       BEQ    LF8C2                        ;2
       DEC    $DD                          ;5
       BNE    LF8C2                        ;2
       LDA    #$00                         ;2
       STA    $DB                          ;3

LF8C2:
       LDA    $DC                          ;3
       BEQ    LF8CE                        ;2
       DEC    $DE                          ;5
       BNE    LF8CE                        ;2
       LDA    #$00                         ;2
       STA    $DC                          ;3

LF8CE:
       LDA    REFP1                        ;3
       AND    PF0                          ;3
       BMI    LF910                        ;2
       LDA    $D3                          ;3
       CMP    $DF                          ;3
       BNE    LF8E5                        ;2
       LDA    $BA                          ;3
       CLC                                 ;2
       ADC    #$04                         ;2
       AND    #$0F                         ;2
       CMP    #$08                         ;2
       BCC    LF910                        ;2

LF8E5:
       LDA    $DF                          ;3
       BEQ    LF910                        ;2
       CMP    $DB                          ;3
       BEQ    LF910                        ;2
       CMP    $DC                          ;3
       BEQ    LF910                        ;2
       LDX    $DB                          ;3
       BNE    LF8FD                        ;2
       STA    $DB                          ;3
       LDX    #$80                         ;2
       STX    $DD                          ;3
       BNE    LF907                        ;2

LF8FD:
       LDX    $DC                          ;3
       BNE    LF910                        ;2
       STA    $DC                          ;3
       LDX    #$80                         ;2
       STX    $DE                          ;3

LF907:
       LDA    #$00                         ;2
       STA    $DF                          ;3
       LDA    #$02                         ;2
       JSR    LF5BC                        ;6

LF910:
       LDA    $BA                          ;3
       AND    #$0F                         ;2
       BNE    LF91F                        ;2
       LDA    $D3                          ;3
       TAX                                 ;2
       AND    #$F8                         ;2
       BEQ    LF91F                        ;2
       STX    $DF                          ;3

LF91F:
       RTS                                 ;6

LF920:
       SEC                                 ;2
       SBC    #$03                         ;2
       STA    $C5                          ;3
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       STA    $C6                          ;3
       LDA    $C5                          ;3
       ASL                                 ;2
       ASL                                 ;2
       ASL                                 ;2
       ASL                                 ;2
       ORA    $C6                          ;3
       CLC                                 ;2
       ADC    $C5                          ;3
       AND    #$F0                         ;2
       ADC    $C6                          ;3
       EOR    #$70                         ;2
       RTS                                 ;6

LF93D:
       LDX    #$0B                         ;2
       LDA    #$00                         ;2

LF941:
       STA    $E1,X                        ;4
       DEX                                 ;2
       BPL    LF941                        ;2
       LDX    #$04                         ;2

LF948:
       LDY    $D5,X                        ;4
       LDA.wy $00BA,Y                      ;4
       CLC                                 ;2
       ADC    #$07                         ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       AND    #$FE                         ;2
       TAY                                 ;2
       TXA                                 ;2
       AND    #$01                         ;2
       BEQ    LF95C                        ;2
       INY                                 ;2

LF95C:
       LDA    $D5,X                        ;4
       STA.wy $00E1,Y                      ;5
       DEX                                 ;2
       BNE    LF948                        ;2
       RTS                                 ;6

LF965:
       JSR    LF969                        ;6

LF968:
       RTS                                 ;6

LF969:
       LDX    #$01                         ;2
       STX    $D5                          ;3
       STX    $D6                          ;3

LF96F:
       INC    $D5                          ;5
       LDX    $D5                          ;3
       CPX    #$05                         ;2
       BEQ    LF968                        ;2
       LDA    $BA,X                        ;4
       LDX    #$01                         ;2

LF97B:
       LDY    $D5,X                        ;4
       CMP.wy $00BA,Y                      ;4
       BCC    LF987                        ;2
       INX                                 ;2
       CPX    $D5                          ;3
       BNE    LF97B                        ;2

LF987:
       LDA    $D5                          ;3
       STA    $D5,X                        ;4

LF98B:
       CPX    $D5                          ;3
       BCS    LF96F                        ;2
       INX                                 ;2
       LDA    $D5,X                        ;4
       STY    $D5,X                        ;4
       TAY                                 ;2
       JMP    LF98B                        ;3

LF998:
       LDX    #$01                         ;2
       JSR    LF9A3                        ;6
       LDX    #$00                         ;2
       JSR    LF9A3                        ;6
       RTS                                 ;6

LF9A3:
       LDA    $8E                          ;3
       AND    #$02                         ;2
       BEQ    LF9D4                        ;2
       LDA    $AD                          ;3
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       AND    #$03                         ;2
       BEQ    LF9D4                        ;2
       CMP    #$01                         ;2
       BEQ    LF9C7                        ;2
       CMP    #$02                         ;2
       BEQ    LF9D4                        ;2
       LDA    #$A3                         ;2
       STA    $EE                          ;3
       LDA    #$E8                         ;2
       STA    $EF                          ;3
       LDA    #$AF                         ;2
       STA    $ED                          ;3
       RTS                                 ;6

LF9C7:
       LDA    #$8C                         ;2
       STA    $EE                          ;3
       LDA    #$D1                         ;2
       STA    $EF                          ;3
       LDA    #$98                         ;2
       STA    $ED                          ;3
       RTS                                 ;6

LF9D4:
       LDA    #$75                         ;2
       STA    $EE                          ;3
       LDA    #$BA                         ;2
       STA    $EF                          ;3
       LDA    #$81                         ;2
       STA    $ED                          ;3
       RTS                                 ;6

LF9E1:
       CPX    #$00                         ;2
       BNE    LF9FA                        ;2
       LDA    $8E                          ;3
       AND    #$40                         ;2
       BEQ    LF9FA                        ;2
       LDA    $B0                          ;3
       CMP    #$4A                         ;2
       BNE    LF9FA                        ;2
       LDA    $BA                          ;3
       CMP    #$58                         ;2
       BNE    LF9FA                        ;2
       LDA    #$D0                         ;2
       RTS                                 ;6

LF9FA:
       JSR    LFA6C                        ;6
       TAY                                 ;2
       LDA    #$F0                         ;2
       CPY    $DB                          ;3
       BEQ    LFA08                        ;2
       CPY    $DC                          ;3
       BNE    LFA14                        ;2

LFA08:
       LDA    $BA,X                        ;4
       AND    #$08                         ;2
       BEQ    LFA10                        ;2
       LDA    #$EF                         ;2

LFA10:
       BNE    LFA14                        ;2
       LDA    #$DF                         ;2

LFA14:
       STA    $CB                          ;3
       LDA    $BA,X                        ;4
       EOR    #$08                         ;2
       AND    #$0F                         ;2
       BNE    LFA2F                        ;2
       LDA    LFA34,Y                      ;4
       AND    $CB                          ;3
       DEY                                 ;2
       CPY    $DB                          ;3
       BEQ    LFA2C                        ;2
       CPY    $DC                          ;3

LFA2A:
       BNE    LFA2E                        ;2

LFA2C:
       AND    #$DF                         ;2

LFA2E:
       RTS                                 ;6

LFA2F:
       LDA    $CB                          ;3
       AND    #$30                         ;2
       RTS                                 ;6

LFA34:
       .byte $C0 ; |XX      | $FA34
       .byte $C0 ; |XX      | $FA35
       .byte $C0 ; |XX      | $FA36
       .byte $C0 ; |XX      | $FA37

LFA38:
       CPY    #$C0                         ;2
       CPY    #$C0                         ;2
       CPY    #$90                         ;2
       BMI    LFA30                        ;2

LFA40:
       BEQ    LF9F2                        ;2

LFA42:
       LDY    #$00                         ;2
       CPY    #$D0                         ;2
       BCS    LFA38                        ;2

LFA48:
       BVS    LFA2A                        ;2

LFA4A:
       CPY    #$00                         ;2
       CPY    #$D0                         ;2
       BVS    LFA40                        ;2

LFA50:
       BCS    LFA42                        ;2
       CPX    #$00                         ;2
       CPY    #$D0                         ;2
       BCS    LFA48                        ;2

LFA58:
       BVS    LFA4A                        ;2
       CPX    #$00                         ;2
       CPY    #$D0                         ;2
       BVS    LFA50                        ;2
       BCS    LFA42                        ;2
       CPY    #$00                         ;2
       CPY    #$50                         ;2
       BMI    LFA58                        ;2
       BEQ    LFADA                        ;2
       RTS                                 ;6

       .byte $00 ; |        | $FA6B

LFA6C:
       LDA    $B0,X                        ;4
       LSR                                 ;2
       BCS    LFA89                        ;2
       LSR                                 ;2
       BCS    LFA89                        ;2
       CMP    #$14                         ;2
       ADC    #$00                         ;2
       LSR                                 ;2
       BCS    LFA89                        ;2
       TAY                                 ;2

LFA7C:
       LDA    $BA,X                        ;4
       CLC                                 ;2
       ADC    #$08                         ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       ORA    LFA8D,Y                      ;4
       RTS                                 ;6

LFA89:
       LDY    #$00                         ;2
       BEQ    LFA7C                        ;2

LFA8D:
       .byte $00 ; |        | $FA8D
       .byte $00 ; |        | $FA8E
       .byte $08 ; |    X   | $FA8F
       .byte $00 ; |        | $FA90
       .byte $00 ; |        | $FA91
       .byte $10 ; |   X    | $FA92
       .byte $00 ; |        | $FA93
       .byte $00 ; |        | $FA94
       .byte $18 ; |   XX   | $FA95
       .byte $00 ; |        | $FA96
       .byte $00 ; |        | $FA97
       .byte $20 ; |  X     | $FA98
       .byte $00 ; |        | $FA99
       .byte $00 ; |        | $FA9A
       .byte $28 ; |  X X   | $FA9B
       .byte $00 ; |        | $FA9C
       .byte $00 ; |        | $FA9D
       .byte $30 ; |  XX    | $FA9E
       .byte $00 ; |        | $FA9F
       .byte $00 ; |        | $FAA0
       .byte $90 ; |X  X    | $FAA1
       .byte $D0 ; |XX X    | $FAA2
       .byte $D0 ; |XX X    | $FAA3
       .byte $D0 ; |XX X    | $FAA4
       .byte $D0 ; |XX X    | $FAA5
       .byte $50 ; | X X    | $FAA6
       .byte $30 ; |  XX    | $FAA7
       .byte $B0 ; |X XX    | $FAA8
       .byte $70 ; | XXX    | $FAA9
       .byte $B0 ; |X XX    | $FAAA
       .byte $70 ; | XXX    | $FAAB
       .byte $30 ; |  XX    | $FAAC
       .byte $B0 ; |X XX    | $FAAD
       .byte $F0 ; |XXXX    | $FAAE
       .byte $F0 ; |XXXX    | $FAAF
       .byte $F0 ; |XXXX    | $FAB0
       .byte $F0 ; |XXXX    | $FAB1
       .byte $70 ; | XXX    | $FAB2
       .byte $B0 ; |X XX    | $FAB3
       .byte $70 ; | XXX    | $FAB4
       .byte $B0 ; |X XX    | $FAB5
       .byte $70 ; | XXX    | $FAB6
       .byte $B0 ; |X XX    | $FAB7
       .byte $70 ; | XXX    | $FAB8
       .byte $B0 ; |X XX    | $FAB9
       .byte $E0 ; |XXX     | $FABA
       .byte $F0 ; |XXXX    | $FABB
       .byte $F0 ; |XXXX    | $FABC
       .byte $E0 ; |XXX     | $FABD
       .byte $70 ; | XXX    | $FABE
       .byte $A0 ; |X X     | $FABF
       .byte $C0 ; |XX      | $FAC0
       .byte $E0 ; |XXX     | $FAC1
       .byte $E0 ; |XXX     | $FAC2
       .byte $C0 ; |XX      | $FAC3
       .byte $60 ; | XX     | $FAC4

LFAC5:
       LDX    #$05                         ;2
       LDA    $AC                          ;3
       BEQ    LFACC                        ;2
       RTS                                 ;6

LFACC:
       STA    $D5,X                        ;4
       DEX                                 ;2
       BPL    LFACC                        ;2
       STA    $D1                          ;3
       LDX    $8B                          ;3
       LDA    $86,X                        ;4
       STA    $CF                          ;3
       LDX    #$04                         ;2

LFADB:
       LDA    #$F0                         ;2
       LDY    $BF,X                        ;4
       BEQ    LFAE9                        ;2
       LDA    #$30                         ;2
       CPY    #$40                         ;2
       BCS    LFAE9                        ;2
       LDA    #$C0                         ;2

LFAE9:
       EOR    $BF,X                        ;4
       STA    $BF,X                        ;4
       JSR    LF9E1                        ;6
       LDY    $86                          ;3
       CPY    #$02                         ;2
       BCS    LFB04                        ;2
       LDY    $B0,X                        ;4
       CPY    #$10                         ;2
       BNE    LFAFE                        ;2
       AND    #$BF                         ;2

LFAFE:
       CPY    #$84                         ;2
       BNE    LFB04                        ;2
       AND    #$7F                         ;2

LFB04:
       TAY                                 ;2
       AND    $BF,X                        ;4
       STA    $C4,X                        ;4
       LDA    #$00                         ;2
       STA    $BF,X                        ;4
       TYA                                 ;2
       BNE    LFB12                        ;2
       INC    $D1                          ;5

LFB12:
       LDA    $BA,X                        ;4
       SEC                                 ;2
       SBC    #$08                         ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAY                                 ;2
       LDA.wy $00D5,Y                      ;4
       CLC                                 ;2
       ADC    #$01                         ;2
       STA.wy $00D5,Y                      ;5
       LDA    $BA,X                        ;4
       EOR    #$08                         ;2
       AND    #$0F                         ;2
       BEQ    LFB36                        ;2
       INY                                 ;2
       LDA.wy $00D5,Y                      ;4
       ADC    #$01                         ;2
       STA.wy $00D5,Y                      ;5

LFB36:
       DEX                                 ;2
       BNE    LFADB                        ;2
       LDY    $D1                          ;3
       BEQ    LFB56                        ;2
       LDA    $8E                          ;3
       AND    #$80                         ;2
       BNE    LFB56                        ;2
       LDY    #$03                         ;2
       JSR    LF6BC                        ;6
       JSR    LF6EC                        ;6
       LDA    #$05                         ;2
       JSR    LF5BC                        ;6
       LDA    $8E                          ;3
       ORA    #$80                         ;2
       STA    $8E                          ;3

LFB56:
       LDX    #$04                         ;2

LFB58:
       LDA    $B0,X                        ;4
       SEC                                 ;2
       SBC    $B0                          ;3
       ADC    #$0E                         ;2
       CMP    #$1C                         ;2
       BCS    LFB7C                        ;2
       JSR    LFBEE                        ;6
       LDA    $BA,X                        ;4
       CMP    $BA                          ;3
       BEQ    LFB7C                        ;2
       LDA    #$20                         ;2
       BCS    LFB72                        ;2
       LDA    #$10                         ;2

LFB72:
       AND    $C4,X                        ;4
       BEQ    LFB98                        ;2
       JSR    LFBC6                        ;6
       JMP    LFB98                        ;3

LFB7C:
       LDA    $BA,X                        ;4
       SEC                                 ;2
       SBC    $BA                          ;3
       ADC    #$0E                         ;2
       CMP    #$1C                         ;2
       BCS    LFB98                        ;2
       LDA    $B0,X                        ;4
       CMP    $B0                          ;3
       LDA    #$80                         ;2
       BCC    LFB91                        ;2
       LDA    #$40                         ;2

LFB91:
       AND    $C4,X                        ;4
       BEQ    LFB98                        ;2
       JSR    LFBC6                        ;6

LFB98:
       DEX                                 ;2
       BNE    LFB58                        ;2
       LDX    #$04                         ;2

LFB9D:
       LDA    $BF,X                        ;4
       BNE    LFBBE                        ;2
       JSR    LFBEE                        ;6
       LDA    $C4,X                        ;4
       BEQ    LFBBE                        ;2
       STA    $CD                          ;3
       TXA                                 ;2
       EOR    $F7                          ;3
       AND    #$03                         ;2
       TAY                                 ;2
       LDA    LFBC2,Y                      ;4
       CLC                                 ;2

LFBB4:
       ROR                                 ;2
       BIT    $CD                          ;3
       BEQ    LFBB4                        ;2
       AND    $CD                          ;3
       JSR    LFBC6                        ;6

LFBBE:
       DEX                                 ;2
       BNE    LFB9D                        ;2
       RTS                                 ;6

LFBC2:
       .byte $88 ; |X   X   | $FBC2
       .byte $44 ; | X   X  | $FBC3
       .byte $22 ; |  X   X | $FBC4
       .byte $11 ; |   X   X| $FBC5

LFBC6:
       STA    $BF,X                        ;4
       AND    #$30                         ;2
       BEQ    LFBED                        ;2
       LDA    $BA,X                        ;4
       EOR    #$08                         ;2
       AND    #$0F                         ;2
       BNE    LFBED                        ;2
       LDA    $BA,X                        ;4
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAY                                 ;2
       DEY                                 ;2
       LDA    $BF,X                        ;4
       CMP    #$10                         ;2
       BNE    LFBE4                        ;2
       INY                                 ;2
       INY                                 ;2

LFBE4:
       LDA.wy $00D5,Y                      ;4
       CLC                                 ;2
       ADC    #$01                         ;2
       STA.wy $00D5,Y                      ;5

LFBED:
       RTS                                 ;6

LFBEE:
       LDA    $BA,X                        ;4
       EOR    #$08                         ;2
       AND    #$0F                         ;2
       BNE    LFBED                        ;2
       LDA    $BA,X                        ;4
       SEC                                 ;2
       SBC    #$08                         ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       LSR                                 ;2
       TAY                                 ;2
       DEY                                 ;2
       LDA.wy $00D5,Y                      ;4
       CMP    #$02                         ;2
       BNE    LFC0E                        ;2
       LDA    $C4,X                        ;4
       AND    #$DF                         ;2
       STA    $C4,X                        ;4

LFC0E:
       INY                                 ;2
       INY                                 ;2
       LDA.wy $00D5,Y                      ;4
       CMP    #$02                         ;2
       BNE    LFC1D                        ;2
       LDA    $C4,X                        ;4
       AND    #$EF                         ;2
       STA    $C4,X                        ;4

LFC1D:
       RTS                                 ;6

LFC1E:
       .byte $02 ; |      X | $FC1E
       .byte $04 ; |     X  | $FC1F
       .byte $06 ; |     XX | $FC20
       .byte $0C ; |    XX  | $FC21

LFC22:
       LDX    $8B                          ;3
       LDY    $86,X                        ;4
       LDA    #$00                         ;2
       STA    $AC                          ;3
       LDX    #$04                         ;2
       LDA    $AF                          ;3
       BEQ    LFC36                        ;2
       LDX    #$00                         ;2
       AND    #$E0                         ;2
       BNE    LFCA3                        ;2

LFC36:
       CPY    #$04                         ;2
       BCS    LFC47                        ;2
       DEC    $E0                          ;5
       BPL    LFC47                        ;2
       LDA    LFC1E,Y                      ;4
       STA    $E0                          ;3
       STA    $AC                          ;3
       LDX    #$00                         ;2

LFC47:
       LDA    $BF,X                        ;4
       BIT    LFCA4                        ;4
       BNE    LFC84                        ;2
       BIT    LFCA5                        ;4
       BNE    LFC90                        ;2
       BIT    LFCA6                        ;4
       BNE    LFC72                        ;2
       BIT    LFCA7                        ;4
       BNE    LFC60                        ;2
       JMP    LFC99                        ;3

LFC60:
       LDA    $B0,X                        ;4
       CLC                                 ;2
       ADC    #$01                         ;2
       CMP    #$90                         ;2
       BNE    LFC6B                        ;2
       LDA    #$05                         ;2

LFC6B:
       STA    $B0,X                        ;4
       LDA    #$03                         ;2
       JMP    LFC99                        ;3

LFC72:
       LDA    $B0,X                        ;4
       SEC                                 ;2
       SBC    #$01                         ;2
       CMP    #$04                         ;2
       BNE    LFC7D                        ;2
       LDA    #$8F                         ;2

LFC7D:
       STA    $B0,X                        ;4
       LDA    #$02                         ;2
       JMP    LFC99                        ;3

LFC84:
       LDA    $BA,X                        ;4
       CLC                                 ;2
       ADC    #$01                         ;2
       STA    $BA,X                        ;4
       LDA    #$00                         ;2
       JMP    LFC99                        ;3

LFC90:
       LDA    $BA,X                        ;4
       SEC                                 ;2
       SBC    #$01                         ;2
       STA    $BA,X                        ;4
       LDA    #$01                         ;2

LFC99:
       LDA    $B0,X                        ;4
       JSR    LF920                        ;6
       STA    $B5,X                        ;4
       DEX                                 ;2
       BPL    LFC47                        ;2

LFCA3:
       RTS                                 ;6

LFCA4:
       .byte $10 ; |   X    | $FCA4

LFCA5:
       .byte $20 ; |  X     | $FCA5

LFCA6:
       .byte $40 ; | X      | $FCA6

LFCA7:
       .byte $80 ; |X       | $FCA7

LFCA8:
       LDX    #$00                         ;2
       JSR    LF9E1                        ;6
       STA    $C6                          ;3
       LDA    SWCHA                        ;4
       ASL                                 ;2
       ASL                                 ;2
       ASL                                 ;2
       ASL                                 ;2
       AND    SWCHA                        ;4
       EOR    #$F0                         ;2
       STA    $C5                          ;3
       BIT    $BF                          ;3
       BEQ    LFCC7                        ;2
       LDY    $BF                          ;3
       CMP    $F2                          ;3
       BEQ    LFCE6                        ;2

LFCC7:
       CPY    #$40                         ;2
       AND    $C6                          ;3
       BCC    LFCCF                        ;2
       AND    #$30                         ;2

LFCCF:
       BCS    LFCD3                        ;2
       AND    #$C0                         ;2

LFCD3:
       BNE    LFCD7                        ;2
       LDA    $C5                          ;3

LFCD7:
       AND    $C6                          ;3
       BEQ    LFCE6                        ;2
       BIT    $BF                          ;3
       BNE    LFCE6                        ;2
       STA    $BF                          ;3
       LDA    $C5                          ;3
       STA    $F2                          ;3
       RTS                                 ;6

LFCE6:
       LDA    $BF                          ;3
       AND    $C6                          ;3
       STA    $BF                          ;3
       LDA    $C5                          ;3
       AND    $F2                          ;3
       STA    $F2                          ;3
       RTS                                 ;6

LFCF3:
       LDA    $F7                          ;3
       ASL                                 ;2
       BCS    LFCFA                        ;2
       EOR    #$91                         ;2

LFCFA:
       STA    $F7                          ;3
       RTS                                 ;6

       .byte $FF ; |XXXXXXXX| $FCFD
       .byte $FF ; |XXXXXXXX| $FCFE
       .byte $FF ; |XXXXXXXX| $FCFF

LFD00:
       .byte $C0 ; |XX      | $FD00
       .byte $C0 ; |XX      | $FD01
       .byte $C0 ; |XX      | $FD02
       .byte $C0 ; |XX      | $FD03
       .byte $C0 ; |XX      | $FD04
       .byte $00 ; |        | $FD05
       .byte $C0 ; |XX      | $FD06
       .byte $00 ; |        | $FD07
       .byte $C0 ; |XX      | $FD08
       .byte $C0 ; |XX      | $FD09
       .byte $C0 ; |XX      | $FD0A
       .byte $C0 ; |XX      | $FD0B
       .byte $C0 ; |XX      | $FD0C

LFD0D:
       .byte $FF ; |XXXXXXXX| $FD0D
       .byte $00 ; |        | $FD0E
       .byte $1C ; |   XXX  | $FD0F
       .byte $1C ; |   XXX  | $FD10
       .byte $1C ; |   XXX  | $FD11
       .byte $00 ; |        | $FD12
       .byte $1C ; |   XXX  | $FD13
       .byte $00 ; |        | $FD14
       .byte $1C ; |   XXX  | $FD15
       .byte $00 ; |        | $FD16
       .byte $1F ; |   XXXXX| $FD17
       .byte $00 ; |        | $FD18
       .byte $FF ; |XXXXXXXX| $FD19

LFD1A:
       .byte $FF ; |XXXXXXXX| $FD1A
       .byte $00 ; |        | $FD1B
       .byte $8E ; |X   XXX | $FD1C
       .byte $80 ; |X       | $FD1D
       .byte $8E ; |X   XXX | $FD1E
       .byte $00 ; |        | $FD1F
       .byte $8E ; |X   XXX | $FD20
       .byte $0E ; |    XXX | $FD21
       .byte $8E ; |X   XXX | $FD22
       .byte $00 ; |        | $FD23
       .byte $8F ; |X   XXXX| $FD24
       .byte $00 ; |        | $FD25
       .byte $FF ; |XXXXXXXX| $FD26
       .byte $FF ; |XXXXXXXX| $FD27
       .byte $FF ; |XXXXXXXX| $FD28
       .byte $FF ; |XXXXXXXX| $FD29
       .byte $FF ; |XXXXXXXX| $FD2A
       .byte $FF ; |XXXXXXXX| $FD2B
       .byte $FF ; |XXXXXXXX| $FD2C
       .byte $FF ; |XXXXXXXX| $FD2D
       .byte $FF ; |XXXXXXXX| $FD2E
       .byte $FF ; |XXXXXXXX| $FD2F
       .byte $FF ; |XXXXXXXX| $FD30
       .byte $FF ; |XXXXXXXX| $FD31
       .byte $FF ; |XXXXXXXX| $FD32
       .byte $FF ; |XXXXXXXX| $FD33
       .byte $FF ; |XXXXXXXX| $FD34
       .byte $FF ; |XXXXXXXX| $FD35
       .byte $FF ; |XXXXXXXX| $FD36
       .byte $FF ; |XXXXXXXX| $FD37
       .byte $FF ; |XXXXXXXX| $FD38
       .byte $FF ; |XXXXXXXX| $FD39
       .byte $FF ; |XXXXXXXX| $FD3A
       .byte $FF ; |XXXXXXXX| $FD3B
       .byte $FF ; |XXXXXXXX| $FD3C
       .byte $FF ; |XXXXXXXX| $FD3D
       .byte $FF ; |XXXXXXXX| $FD3E
       .byte $FF ; |XXXXXXXX| $FD3F
       .byte $FF ; |XXXXXXXX| $FD40
       .byte $FF ; |XXXXXXXX| $FD41
       .byte $FF ; |XXXXXXXX| $FD42
       .byte $FF ; |XXXXXXXX| $FD43
       .byte $FF ; |XXXXXXXX| $FD44
       .byte $FF ; |XXXXXXXX| $FD45
       .byte $FF ; |XXXXXXXX| $FD46
       .byte $FF ; |XXXXXXXX| $FD47
       .byte $FF ; |XXXXXXXX| $FD48
       .byte $FF ; |XXXXXXXX| $FD49
       .byte $FF ; |XXXXXXXX| $FD4A
       .byte $FF ; |XXXXXXXX| $FD4B
       .byte $FF ; |XXXXXXXX| $FD4C
       .byte $FF ; |XXXXXXXX| $FD4D
       .byte $FF ; |XXXXXXXX| $FD4E
       .byte $FF ; |XXXXXXXX| $FD4F
       .byte $FF ; |XXXXXXXX| $FD50
       .byte $FF ; |XXXXXXXX| $FD51
       .byte $FF ; |XXXXXXXX| $FD52
       .byte $FF ; |XXXXXXXX| $FD53
       .byte $FF ; |XXXXXXXX| $FD54
       .byte $FF ; |XXXXXXXX| $FD55
       .byte $FF ; |XXXXXXXX| $FD56
       .byte $FF ; |XXXXXXXX| $FD57
       .byte $FF ; |XXXXXXXX| $FD58
       .byte $FF ; |XXXXXXXX| $FD59
       .byte $FF ; |XXXXXXXX| $FD5A
       .byte $FF ; |XXXXXXXX| $FD5B
       .byte $FF ; |XXXXXXXX| $FD5C
       .byte $FF ; |XXXXXXXX| $FD5D
       .byte $FF ; |XXXXXXXX| $FD5E
       .byte $FF ; |XXXXXXXX| $FD5F
       .byte $FF ; |XXXXXXXX| $FD60
       .byte $FF ; |XXXXXXXX| $FD61
       .byte $FF ; |XXXXXXXX| $FD62
       .byte $FF ; |XXXXXXXX| $FD63
       .byte $00 ; |        | $FD64
       .byte $00 ; |        | $FD65
       .byte $00 ; |        | $FD66
       .byte $00 ; |        | $FD67
       .byte $00 ; |        | $FD68
       .byte $00 ; |        | $FD69
       .byte $00 ; |        | $FD6A
       .byte $00 ; |        | $FD6B
       .byte $00 ; |        | $FD6C
       .byte $00 ; |        | $FD6D
       .byte $00 ; |        | $FD6E
       .byte $00 ; |        | $FD6F
       .byte $00 ; |        | $FD70
       .byte $00 ; |        | $FD71
       .byte $00 ; |        | $FD72
       .byte $00 ; |        | $FD73
       .byte $3C ; |  XXXX  | $FD74
       .byte $3C ; |  XXXX  | $FD75
       .byte $3C ; |  XXXX  | $FD76
       .byte $FF ; |XXXXXXXX| $FD77
       .byte $FF ; |XXXXXXXX| $FD78
       .byte $00 ; |        | $FD79
       .byte $3C ; |  XXXX  | $FD7A
       .byte $00 ; |        | $FD7B
       .byte $00 ; |        | $FD7C
       .byte $00 ; |        | $FD7D
       .byte $00 ; |        | $FD7E
       .byte $00 ; |        | $FD7F
       .byte $00 ; |        | $FD80
       .byte $00 ; |        | $FD81
       .byte $00 ; |        | $FD82
       .byte $00 ; |        | $FD83
       .byte $00 ; |        | $FD84
       .byte $00 ; |        | $FD85
       .byte $00 ; |        | $FD86
       .byte $00 ; |        | $FD87
       .byte $00 ; |        | $FD88
       .byte $00 ; |        | $FD89
       .byte $00 ; |        | $FD8A
       .byte $30 ; |  XX    | $FD8B
       .byte $3C ; |  XXXX  | $FD8C
       .byte $3C ; |  XXXX  | $FD8D
       .byte $FF ; |XXXXXXXX| $FD8E
       .byte $FF ; |XXXXXXXX| $FD8F
       .byte $00 ; |        | $FD90
       .byte $3C ; |  XXXX  | $FD91
       .byte $00 ; |        | $FD92
       .byte $00 ; |        | $FD93
       .byte $00 ; |        | $FD94
       .byte $00 ; |        | $FD95
       .byte $00 ; |        | $FD96
       .byte $00 ; |        | $FD97
       .byte $00 ; |        | $FD98
       .byte $00 ; |        | $FD99
       .byte $00 ; |        | $FD9A
       .byte $00 ; |        | $FD9B
       .byte $00 ; |        | $FD9C
       .byte $00 ; |        | $FD9D
       .byte $00 ; |        | $FD9E
       .byte $00 ; |        | $FD9F
       .byte $00 ; |        | $FDA0
       .byte $00 ; |        | $FDA1
       .byte $0C ; |    XX  | $FDA2
       .byte $3C ; |  XXXX  | $FDA3
       .byte $3C ; |  XXXX  | $FDA4
       .byte $FF ; |XXXXXXXX| $FDA5
       .byte $FF ; |XXXXXXXX| $FDA6
       .byte $00 ; |        | $FDA7
       .byte $3C ; |  XXXX  | $FDA8
       .byte $00 ; |        | $FDA9
       .byte $00 ; |        | $FDAA
       .byte $00 ; |        | $FDAB
       .byte $00 ; |        | $FDAC
       .byte $00 ; |        | $FDAD
       .byte $00 ; |        | $FDAE
       .byte $00 ; |        | $FDAF
       .byte $00 ; |        | $FDB0
       .byte $00 ; |        | $FDB1
       .byte $00 ; |        | $FDB2
       .byte $00 ; |        | $FDB3
       .byte $00 ; |        | $FDB4
       .byte $00 ; |        | $FDB5
       .byte $00 ; |        | $FDB6
       .byte $00 ; |        | $FDB7
       .byte $00 ; |        | $FDB8
       .byte $0A ; |    X X | $FDB9
       .byte $0A ; |    X X | $FDBA
       .byte $EA ; |XXX X X | $FDBB
       .byte $0E ; |    XXX | $FDBC
       .byte $0E ; |    XXX | $FDBD
       .byte $20 ; |  X     | $FDBE
       .byte $DA ; |XX XX X | $FDBF
       .byte $00 ; |        | $FDC0
       .byte $00 ; |        | $FDC1
       .byte $00 ; |        | $FDC2
       .byte $00 ; |        | $FDC3
       .byte $00 ; |        | $FDC4
       .byte $00 ; |        | $FDC5
       .byte $00 ; |        | $FDC6
       .byte $00 ; |        | $FDC7
       .byte $00 ; |        | $FDC8
       .byte $00 ; |        | $FDC9
       .byte $00 ; |        | $FDCA
       .byte $00 ; |        | $FDCB
       .byte $00 ; |        | $FDCC
       .byte $00 ; |        | $FDCD
       .byte $00 ; |        | $FDCE
       .byte $00 ; |        | $FDCF
       .byte $06 ; |     XX | $FDD0
       .byte $0A ; |    X X | $FDD1
       .byte $EA ; |XXX X X | $FDD2
       .byte $0E ; |    XXX | $FDD3
       .byte $0E ; |    XXX | $FDD4
       .byte $20 ; |  X     | $FDD5
       .byte $DA ; |XX XX X | $FDD6
       .byte $00 ; |        | $FDD7
       .byte $00 ; |        | $FDD8
       .byte $00 ; |        | $FDD9
       .byte $00 ; |        | $FDDA
       .byte $00 ; |        | $FDDB
       .byte $00 ; |        | $FDDC
       .byte $00 ; |        | $FDDD
       .byte $00 ; |        | $FDDE
       .byte $00 ; |        | $FDDF
       .byte $00 ; |        | $FDE0
       .byte $00 ; |        | $FDE1
       .byte $00 ; |        | $FDE2
       .byte $00 ; |        | $FDE3
       .byte $00 ; |        | $FDE4
       .byte $00 ; |        | $FDE5
       .byte $00 ; |        | $FDE6
       .byte $E6 ; |XXX  XX | $FDE7
       .byte $0A ; |    X X | $FDE8
       .byte $EA ; |XXX X X | $FDE9
       .byte $0E ; |    XXX | $FDEA
       .byte $0E ; |    XXX | $FDEB
       .byte $20 ; |  X     | $FDEC
       .byte $DA ; |XX XX X | $FDED
       .byte $00 ; |        | $FDEE
       .byte $00 ; |        | $FDEF
       .byte $00 ; |        | $FDF0
       .byte $00 ; |        | $FDF1
       .byte $00 ; |        | $FDF2
       .byte $00 ; |        | $FDF3
       .byte $00 ; |        | $FDF4
       .byte $00 ; |        | $FDF5
       .byte $00 ; |        | $FDF6
       .byte $00 ; |        | $FDF7
       .byte $00 ; |        | $FDF8
       .byte $00 ; |        | $FDF9
       .byte $00 ; |        | $FDFA
       .byte $00 ; |        | $FDFB
       .byte $00 ; |        | $FDFC
       .byte $00 ; |        | $FDFD
       .byte $FF ; |XXXXXXXX| $FDFE
       .byte $FF ; |XXXXXXXX| $FDFF
       .byte $FE ; |XXXXXXX | $FE00
       .byte $C6 ; |XX   XX | $FE01
       .byte $D6 ; |XX X XX | $FE02
       .byte $D6 ; |XX X XX | $FE03
       .byte $C6 ; |XX   XX | $FE04
       .byte $FE ; |XXXXXXX | $FE05
       .byte $00 ; |        | $FE06
       .byte $00 ; |        | $FE07
       .byte $7E ; | XXXXXX | $FE08
       .byte $18 ; |   XX   | $FE09
       .byte $18 ; |   XX   | $FE0A
       .byte $18 ; |   XX   | $FE0B
       .byte $18 ; |   XX   | $FE0C
       .byte $38 ; |  XXX   | $FE0D
       .byte $00 ; |        | $FE0E
       .byte $00 ; |        | $FE0F
       .byte $7E ; | XXXXXX | $FE10
       .byte $60 ; | XX     | $FE11
       .byte $7E ; | XXXXXX | $FE12
       .byte $06 ; |     XX | $FE13
       .byte $66 ; | XX  XX | $FE14
       .byte $7E ; | XXXXXX | $FE15
       .byte $00 ; |        | $FE16
       .byte $00 ; |        | $FE17
       .byte $7E ; | XXXXXX | $FE18
       .byte $06 ; |     XX | $FE19
       .byte $06 ; |     XX | $FE1A
       .byte $3C ; |  XXXX  | $FE1B
       .byte $06 ; |     XX | $FE1C
       .byte $7E ; | XXXXXX | $FE1D
       .byte $00 ; |        | $FE1E
       .byte $00 ; |        | $FE1F
       .byte $06 ; |     XX | $FE20
       .byte $06 ; |     XX | $FE21
       .byte $7E ; | XXXXXX | $FE22
       .byte $66 ; | XX  XX | $FE23
       .byte $66 ; | XX  XX | $FE24
       .byte $66 ; | XX  XX | $FE25
       .byte $00 ; |        | $FE26
       .byte $00 ; |        | $FE27
       .byte $7E ; | XXXXXX | $FE28
       .byte $66 ; | XX  XX | $FE29
       .byte $06 ; |     XX | $FE2A
       .byte $7E ; | XXXXXX | $FE2B
       .byte $60 ; | XX     | $FE2C
       .byte $7E ; | XXXXXX | $FE2D
       .byte $00 ; |        | $FE2E
       .byte $00 ; |        | $FE2F
       .byte $7E ; | XXXXXX | $FE30
       .byte $66 ; | XX  XX | $FE31
       .byte $66 ; | XX  XX | $FE32
       .byte $7E ; | XXXXXX | $FE33
       .byte $60 ; | XX     | $FE34
       .byte $7E ; | XXXXXX | $FE35
       .byte $00 ; |        | $FE36
       .byte $00 ; |        | $FE37
       .byte $30 ; |  XX    | $FE38
       .byte $30 ; |  XX    | $FE39
       .byte $18 ; |   XX   | $FE3A
       .byte $0C ; |    XX  | $FE3B
       .byte $06 ; |     XX | $FE3C
       .byte $7E ; | XXXXXX | $FE3D
       .byte $00 ; |        | $FE3E
       .byte $00 ; |        | $FE3F
       .byte $7E ; | XXXXXX | $FE40
       .byte $66 ; | XX  XX | $FE41
       .byte $66 ; | XX  XX | $FE42
       .byte $3C ; |  XXXX  | $FE43
       .byte $66 ; | XX  XX | $FE44
       .byte $7E ; | XXXXXX | $FE45
       .byte $00 ; |        | $FE46
       .byte $00 ; |        | $FE47
       .byte $7E ; | XXXXXX | $FE48
       .byte $06 ; |     XX | $FE49
       .byte $7E ; | XXXXXX | $FE4A
       .byte $66 ; | XX  XX | $FE4B
       .byte $66 ; | XX  XX | $FE4C
       .byte $7E ; | XXXXXX | $FE4D
       .byte $00 ; |        | $FE4E
       .byte $00 ; |        | $FE4F
       .byte $00 ; |        | $FE50
       .byte $00 ; |        | $FE51
       .byte $00 ; |        | $FE52
       .byte $00 ; |        | $FE53
       .byte $00 ; |        | $FE54
       .byte $00 ; |        | $FE55
       .byte $00 ; |        | $FE56
       .byte $00 ; |        | $FE57
       .byte $08 ; |    X   | $FE58
       .byte $08 ; |    X   | $FE59
       .byte $3E ; |  XXXXX | $FE5A
       .byte $08 ; |    X   | $FE5B
       .byte $08 ; |    X   | $FE5C
       .byte $00 ; |        | $FE5D
       .byte $00 ; |        | $FE5E
       .byte $00 ; |        | $FE5F
       .byte $66 ; | XX  XX | $FE60
       .byte $24 ; |  X  X  | $FE61
       .byte $7E ; | XXXXXX | $FE62
       .byte $3C ; |  XXXX  | $FE63
       .byte $3C ; |  XXXX  | $FE64
       .byte $3C ; |  XXXX  | $FE65
       .byte $00 ; |        | $FE66
       .byte $00 ; |        | $FE67
       .byte $FF ; |XXXXXXXX| $FE68
       .byte $FF ; |XXXXXXXX| $FE69
       .byte $FF ; |XXXXXXXX| $FE6A
       .byte $FF ; |XXXXXXXX| $FE6B
       .byte $FF ; |XXXXXXXX| $FE6C
       .byte $FF ; |XXXXXXXX| $FE6D
       .byte $FF ; |XXXXXXXX| $FE6E
       .byte $FF ; |XXXXXXXX| $FE6F
       .byte $00 ; |        | $FE70
       .byte $00 ; |        | $FE71
       .byte $00 ; |        | $FE72
       .byte $00 ; |        | $FE73
       .byte $00 ; |        | $FE74
       .byte $00 ; |        | $FE75
       .byte $00 ; |        | $FE76
       .byte $00 ; |        | $FE77
       .byte $00 ; |        | $FE78
       .byte $00 ; |        | $FE79
       .byte $00 ; |        | $FE7A
       .byte $00 ; |        | $FE7B
       .byte $00 ; |        | $FE7C
       .byte $00 ; |        | $FE7D
       .byte $00 ; |        | $FE7E
       .byte $00 ; |        | $FE7F
       .byte $66 ; | XX  XX | $FE80
       .byte $24 ; |  X  X  | $FE81
       .byte $FF ; |XXXXXXXX| $FE82
       .byte $3C ; |  XXXX  | $FE83
       .byte $3C ; |  XXXX  | $FE84
       .byte $00 ; |        | $FE85
       .byte $00 ; |        | $FE86
       .byte $00 ; |        | $FE87
       .byte $00 ; |        | $FE88
       .byte $00 ; |        | $FE89
       .byte $00 ; |        | $FE8A
       .byte $00 ; |        | $FE8B
       .byte $00 ; |        | $FE8C
       .byte $00 ; |        | $FE8D
       .byte $00 ; |        | $FE8E
       .byte $00 ; |        | $FE8F
       .byte $00 ; |        | $FE90
       .byte $00 ; |        | $FE91
       .byte $00 ; |        | $FE92
       .byte $00 ; |        | $FE93
       .byte $00 ; |        | $FE94
       .byte $00 ; |        | $FE95
       .byte $00 ; |        | $FE96
       .byte $06 ; |     XX | $FE97
       .byte $64 ; | XX  X  | $FE98
       .byte $FF ; |XXXXXXXX| $FE99
       .byte $3C ; |  XXXX  | $FE9A
       .byte $3C ; |  XXXX  | $FE9B
       .byte $00 ; |        | $FE9C
       .byte $00 ; |        | $FE9D
       .byte $00 ; |        | $FE9E
       .byte $00 ; |        | $FE9F
       .byte $00 ; |        | $FEA0
       .byte $00 ; |        | $FEA1
       .byte $00 ; |        | $FEA2
       .byte $00 ; |        | $FEA3
       .byte $00 ; |        | $FEA4
       .byte $00 ; |        | $FEA5
       .byte $00 ; |        | $FEA6
       .byte $00 ; |        | $FEA7
       .byte $00 ; |        | $FEA8
       .byte $00 ; |        | $FEA9
       .byte $00 ; |        | $FEAA
       .byte $00 ; |        | $FEAB
       .byte $00 ; |        | $FEAC
       .byte $00 ; |        | $FEAD
       .byte $60 ; | XX     | $FEAE
       .byte $26 ; |  X  XX | $FEAF
       .byte $FF ; |XXXXXXXX| $FEB0
       .byte $3C ; |  XXXX  | $FEB1
       .byte $3C ; |  XXXX  | $FEB2
       .byte $00 ; |        | $FEB3
       .byte $00 ; |        | $FEB4
       .byte $00 ; |        | $FEB5
       .byte $00 ; |        | $FEB6
       .byte $00 ; |        | $FEB7
       .byte $00 ; |        | $FEB8
       .byte $00 ; |        | $FEB9
       .byte $00 ; |        | $FEBA
       .byte $00 ; |        | $FEBB
       .byte $00 ; |        | $FEBC
       .byte $00 ; |        | $FEBD
       .byte $00 ; |        | $FEBE
       .byte $00 ; |        | $FEBF
       .byte $00 ; |        | $FEC0
       .byte $00 ; |        | $FEC1
       .byte $00 ; |        | $FEC2
       .byte $00 ; |        | $FEC3
       .byte $00 ; |        | $FEC4
       .byte $FF ; |XXXXXXXX| $FEC5
       .byte $FF ; |XXXXXXXX| $FEC6
       .byte $FF ; |XXXXXXXX| $FEC7
       .byte $FF ; |XXXXXXXX| $FEC8
       .byte $FF ; |XXXXXXXX| $FEC9
       .byte $FF ; |XXXXXXXX| $FECA
       .byte $FF ; |XXXXXXXX| $FECB
       .byte $FF ; |XXXXXXXX| $FECC
       .byte $FF ; |XXXXXXXX| $FECD
       .byte $FF ; |XXXXXXXX| $FECE
       .byte $FF ; |XXXXXXXX| $FECF
       .byte $FF ; |XXXXXXXX| $FED0
       .byte $FF ; |XXXXXXXX| $FED1
       .byte $FF ; |XXXXXXXX| $FED2
       .byte $FF ; |XXXXXXXX| $FED3
       .byte $FF ; |XXXXXXXX| $FED4
       .byte $FF ; |XXXXXXXX| $FED5
       .byte $FF ; |XXXXXXXX| $FED6
       .byte $FF ; |XXXXXXXX| $FED7
       .byte $FF ; |XXXXXXXX| $FED8
       .byte $FF ; |XXXXXXXX| $FED9
       .byte $FF ; |XXXXXXXX| $FEDA
       .byte $FF ; |XXXXXXXX| $FEDB
       .byte $FF ; |XXXXXXXX| $FEDC
       .byte $FF ; |XXXXXXXX| $FEDD
       .byte $FF ; |XXXXXXXX| $FEDE
       .byte $FF ; |XXXXXXXX| $FEDF
       .byte $FF ; |XXXXXXXX| $FEE0
       .byte $FF ; |XXXXXXXX| $FEE1
       .byte $FF ; |XXXXXXXX| $FEE2
       .byte $FF ; |XXXXXXXX| $FEE3
       .byte $FF ; |XXXXXXXX| $FEE4
       .byte $FF ; |XXXXXXXX| $FEE5
       .byte $FF ; |XXXXXXXX| $FEE6
       .byte $FF ; |XXXXXXXX| $FEE7
       .byte $FF ; |XXXXXXXX| $FEE8
       .byte $FF ; |XXXXXXXX| $FEE9
       .byte $FF ; |XXXXXXXX| $FEEA
       .byte $FF ; |XXXXXXXX| $FEEB
       .byte $FF ; |XXXXXXXX| $FEEC
       .byte $FF ; |XXXXXXXX| $FEED
       .byte $FF ; |XXXXXXXX| $FEEE
       .byte $FF ; |XXXXXXXX| $FEEF
       .byte $FF ; |XXXXXXXX| $FEF0
       .byte $FF ; |XXXXXXXX| $FEF1
       .byte $FF ; |XXXXXXXX| $FEF2
       .byte $FF ; |XXXXXXXX| $FEF3
       .byte $FF ; |XXXXXXXX| $FEF4
       .byte $FF ; |XXXXXXXX| $FEF5
       .byte $FF ; |XXXXXXXX| $FEF6
       .byte $FF ; |XXXXXXXX| $FEF7
       .byte $FF ; |XXXXXXXX| $FEF8
       .byte $FF ; |XXXXXXXX| $FEF9
       .byte $FF ; |XXXXXXXX| $FEFA
       .byte $FF ; |XXXXXXXX| $FEFB
       .byte $FF ; |XXXXXXXX| $FEFC
       .byte $FF ; |XXXXXXXX| $FEFD
       .byte $FF ; |XXXXXXXX| $FEFE
       .byte $FF ; |XXXXXXXX| $FEFF
       .byte $FF ; |XXXXXXXX| $FF00
       .byte $FF ; |XXXXXXXX| $FF01
       .byte $FF ; |XXXXXXXX| $FF02
       .byte $FF ; |XXXXXXXX| $FF03
       .byte $FF ; |XXXXXXXX| $FF04
       .byte $FF ; |XXXXXXXX| $FF05
       .byte $FF ; |XXXXXXXX| $FF06
       .byte $FF ; |XXXXXXXX| $FF07
       .byte $FF ; |XXXXXXXX| $FF08
       .byte $FF ; |XXXXXXXX| $FF09
       .byte $FF ; |XXXXXXXX| $FF0A
       .byte $FF ; |XXXXXXXX| $FF0B
       .byte $FF ; |XXXXXXXX| $FF0C
       .byte $FF ; |XXXXXXXX| $FF0D
       .byte $FF ; |XXXXXXXX| $FF0E
       .byte $FF ; |XXXXXXXX| $FF0F
       .byte $FF ; |XXXXXXXX| $FF10
       .byte $FF ; |XXXXXXXX| $FF11
       .byte $FF ; |XXXXXXXX| $FF12
       .byte $FF ; |XXXXXXXX| $FF13
       .byte $FF ; |XXXXXXXX| $FF14
       .byte $FF ; |XXXXXXXX| $FF15
       .byte $FF ; |XXXXXXXX| $FF16
       .byte $FF ; |XXXXXXXX| $FF17
       .byte $FF ; |XXXXXXXX| $FF18
       .byte $FF ; |XXXXXXXX| $FF19
       .byte $FF ; |XXXXXXXX| $FF1A
       .byte $FF ; |XXXXXXXX| $FF1B
       .byte $FF ; |XXXXXXXX| $FF1C
       .byte $FF ; |XXXXXXXX| $FF1D
       .byte $FF ; |XXXXXXXX| $FF1E
       .byte $FF ; |XXXXXXXX| $FF1F
       .byte $FF ; |XXXXXXXX| $FF20
       .byte $FF ; |XXXXXXXX| $FF21
       .byte $FF ; |XXXXXXXX| $FF22
       .byte $FF ; |XXXXXXXX| $FF23
       .byte $FF ; |XXXXXXXX| $FF24
       .byte $FF ; |XXXXXXXX| $FF25
       .byte $FF ; |XXXXXXXX| $FF26
       .byte $FF ; |XXXXXXXX| $FF27
       .byte $FF ; |XXXXXXXX| $FF28
       .byte $FF ; |XXXXXXXX| $FF29
       .byte $FF ; |XXXXXXXX| $FF2A
       .byte $FF ; |XXXXXXXX| $FF2B
       .byte $FF ; |XXXXXXXX| $FF2C
       .byte $FF ; |XXXXXXXX| $FF2D
       .byte $FF ; |XXXXXXXX| $FF2E
       .byte $FF ; |XXXXXXXX| $FF2F
       .byte $FF ; |XXXXXXXX| $FF30
       .byte $FF ; |XXXXXXXX| $FF31
       .byte $FF ; |XXXXXXXX| $FF32
       .byte $FF ; |XXXXXXXX| $FF33
       .byte $FF ; |XXXXXXXX| $FF34
       .byte $FF ; |XXXXXXXX| $FF35
       .byte $FF ; |XXXXXXXX| $FF36
       .byte $FF ; |XXXXXXXX| $FF37
       .byte $FF ; |XXXXXXXX| $FF38
       .byte $FF ; |XXXXXXXX| $FF39
       .byte $FF ; |XXXXXXXX| $FF3A
       .byte $FF ; |XXXXXXXX| $FF3B
       .byte $FF ; |XXXXXXXX| $FF3C
       .byte $FF ; |XXXXXXXX| $FF3D
       .byte $FF ; |XXXXXXXX| $FF3E
       .byte $FF ; |XXXXXXXX| $FF3F
       .byte $FF ; |XXXXXXXX| $FF40
       .byte $FF ; |XXXXXXXX| $FF41
       .byte $FF ; |XXXXXXXX| $FF42
       .byte $FF ; |XXXXXXXX| $FF43
       .byte $FF ; |XXXXXXXX| $FF44
       .byte $FF ; |XXXXXXXX| $FF45
       .byte $FF ; |XXXXXXXX| $FF46
       .byte $FF ; |XXXXXXXX| $FF47
       .byte $FF ; |XXXXXXXX| $FF48
       .byte $FF ; |XXXXXXXX| $FF49
       .byte $FF ; |XXXXXXXX| $FF4A
       .byte $FF ; |XXXXXXXX| $FF4B
       .byte $FF ; |XXXXXXXX| $FF4C
       .byte $FF ; |XXXXXXXX| $FF4D
       .byte $FF ; |XXXXXXXX| $FF4E
       .byte $FF ; |XXXXXXXX| $FF4F
       .byte $FF ; |XXXXXXXX| $FF50
       .byte $FF ; |XXXXXXXX| $FF51
       .byte $FF ; |XXXXXXXX| $FF52
       .byte $FF ; |XXXXXXXX| $FF53
       .byte $FF ; |XXXXXXXX| $FF54
       .byte $FF ; |XXXXXXXX| $FF55
       .byte $FF ; |XXXXXXXX| $FF56
       .byte $FF ; |XXXXXXXX| $FF57
       .byte $FF ; |XXXXXXXX| $FF58
       .byte $FF ; |XXXXXXXX| $FF59
       .byte $FF ; |XXXXXXXX| $FF5A
       .byte $FF ; |XXXXXXXX| $FF5B
       .byte $FF ; |XXXXXXXX| $FF5C
       .byte $FF ; |XXXXXXXX| $FF5D
       .byte $FF ; |XXXXXXXX| $FF5E
       .byte $FF ; |XXXXXXXX| $FF5F
       .byte $FF ; |XXXXXXXX| $FF60
       .byte $FF ; |XXXXXXXX| $FF61
       .byte $FF ; |XXXXXXXX| $FF62
       .byte $FF ; |XXXXXXXX| $FF63
       .byte $FF ; |XXXXXXXX| $FF64
       .byte $FF ; |XXXXXXXX| $FF65
       .byte $FF ; |XXXXXXXX| $FF66
       .byte $FF ; |XXXXXXXX| $FF67
       .byte $FF ; |XXXXXXXX| $FF68
       .byte $FF ; |XXXXXXXX| $FF69
       .byte $FF ; |XXXXXXXX| $FF6A
       .byte $FF ; |XXXXXXXX| $FF6B
       .byte $FF ; |XXXXXXXX| $FF6C
       .byte $FF ; |XXXXXXXX| $FF6D
       .byte $FF ; |XXXXXXXX| $FF6E
       .byte $FF ; |XXXXXXXX| $FF6F
       .byte $FF ; |XXXXXXXX| $FF70
       .byte $FF ; |XXXXXXXX| $FF71
       .byte $FF ; |XXXXXXXX| $FF72
       .byte $FF ; |XXXXXXXX| $FF73
       .byte $FF ; |XXXXXXXX| $FF74
       .byte $FF ; |XXXXXXXX| $FF75
       .byte $FF ; |XXXXXXXX| $FF76
       .byte $FF ; |XXXXXXXX| $FF77
       .byte $FF ; |XXXXXXXX| $FF78
       .byte $FF ; |XXXXXXXX| $FF79
       .byte $FF ; |XXXXXXXX| $FF7A
       .byte $FF ; |XXXXXXXX| $FF7B
       .byte $FF ; |XXXXXXXX| $FF7C
       .byte $FF ; |XXXXXXXX| $FF7D
       .byte $FF ; |XXXXXXXX| $FF7E
       .byte $FF ; |XXXXXXXX| $FF7F
       .byte $FF ; |XXXXXXXX| $FF80
       .byte $FF ; |XXXXXXXX| $FF81
       .byte $FF ; |XXXXXXXX| $FF82
       .byte $FF ; |XXXXXXXX| $FF83
       .byte $FF ; |XXXXXXXX| $FF84
       .byte $FF ; |XXXXXXXX| $FF85
       .byte $FF ; |XXXXXXXX| $FF86
       .byte $FF ; |XXXXXXXX| $FF87
       .byte $FF ; |XXXXXXXX| $FF88
       .byte $FF ; |XXXXXXXX| $FF89
       .byte $FF ; |XXXXXXXX| $FF8A
       .byte $FF ; |XXXXXXXX| $FF8B
       .byte $FF ; |XXXXXXXX| $FF8C
       .byte $FF ; |XXXXXXXX| $FF8D
       .byte $FF ; |XXXXXXXX| $FF8E
       .byte $FF ; |XXXXXXXX| $FF8F
       .byte $FF ; |XXXXXXXX| $FF90
       .byte $FF ; |XXXXXXXX| $FF91
       .byte $FF ; |XXXXXXXX| $FF92
       .byte $FF ; |XXXXXXXX| $FF93
       .byte $FF ; |XXXXXXXX| $FF94
       .byte $FF ; |XXXXXXXX| $FF95
       .byte $FF ; |XXXXXXXX| $FF96
       .byte $FF ; |XXXXXXXX| $FF97
       .byte $FF ; |XXXXXXXX| $FF98
       .byte $FF ; |XXXXXXXX| $FF99
       .byte $FF ; |XXXXXXXX| $FF9A
       .byte $FF ; |XXXXXXXX| $FF9B
       .byte $FF ; |XXXXXXXX| $FF9C
       .byte $FF ; |XXXXXXXX| $FF9D
       .byte $FF ; |XXXXXXXX| $FF9E
       .byte $FF ; |XXXXXXXX| $FF9F
       .byte $FF ; |XXXXXXXX| $FFA0
       .byte $FF ; |XXXXXXXX| $FFA1
       .byte $FF ; |XXXXXXXX| $FFA2
       .byte $FF ; |XXXXXXXX| $FFA3
       .byte $FF ; |XXXXXXXX| $FFA4
       .byte $FF ; |XXXXXXXX| $FFA5
       .byte $FF ; |XXXXXXXX| $FFA6
       .byte $FF ; |XXXXXXXX| $FFA7
       .byte $FF ; |XXXXXXXX| $FFA8
       .byte $FF ; |XXXXXXXX| $FFA9
       .byte $FF ; |XXXXXXXX| $FFAA
       .byte $FF ; |XXXXXXXX| $FFAB
       .byte $FF ; |XXXXXXXX| $FFAC
       .byte $FF ; |XXXXXXXX| $FFAD
       .byte $FF ; |XXXXXXXX| $FFAE
       .byte $FF ; |XXXXXXXX| $FFAF
       .byte $FF ; |XXXXXXXX| $FFB0
       .byte $FF ; |XXXXXXXX| $FFB1
       .byte $FF ; |XXXXXXXX| $FFB2
       .byte $FF ; |XXXXXXXX| $FFB3
       .byte $FF ; |XXXXXXXX| $FFB4
       .byte $FF ; |XXXXXXXX| $FFB5
       .byte $FF ; |XXXXXXXX| $FFB6
       .byte $FF ; |XXXXXXXX| $FFB7
       .byte $FF ; |XXXXXXXX| $FFB8
       .byte $FF ; |XXXXXXXX| $FFB9
       .byte $FF ; |XXXXXXXX| $FFBA
       .byte $FF ; |XXXXXXXX| $FFBB
       .byte $FF ; |XXXXXXXX| $FFBC
       .byte $FF ; |XXXXXXXX| $FFBD
       .byte $FF ; |XXXXXXXX| $FFBE
       .byte $FF ; |XXXXXXXX| $FFBF
       .byte $FF ; |XXXXXXXX| $FFC0
       .byte $FF ; |XXXXXXXX| $FFC1
       .byte $FF ; |XXXXXXXX| $FFC2
       .byte $FF ; |XXXXXXXX| $FFC3
       .byte $FF ; |XXXXXXXX| $FFC4
       .byte $FF ; |XXXXXXXX| $FFC5
       .byte $FF ; |XXXXXXXX| $FFC6
       .byte $FF ; |XXXXXXXX| $FFC7
       .byte $FF ; |XXXXXXXX| $FFC8
       .byte $FF ; |XXXXXXXX| $FFC9
       .byte $FF ; |XXXXXXXX| $FFCA
       .byte $FF ; |XXXXXXXX| $FFCB
       .byte $FF ; |XXXXXXXX| $FFCC
       .byte $FF ; |XXXXXXXX| $FFCD
       .byte $FF ; |XXXXXXXX| $FFCE
       .byte $FF ; |XXXXXXXX| $FFCF
       .byte $FF ; |XXXXXXXX| $FFD0
       .byte $FF ; |XXXXXXXX| $FFD1
       .byte $FF ; |XXXXXXXX| $FFD2
       .byte $FF ; |XXXXXXXX| $FFD3
       .byte $FF ; |XXXXXXXX| $FFD4
       .byte $FF ; |XXXXXXXX| $FFD5
       .byte $FF ; |XXXXXXXX| $FFD6
       .byte $FF ; |XXXXXXXX| $FFD7
       .byte $FF ; |XXXXXXXX| $FFD8
       .byte $FF ; |XXXXXXXX| $FFD9
       .byte $FF ; |XXXXXXXX| $FFDA
       .byte $FF ; |XXXXXXXX| $FFDB
       .byte $FF ; |XXXXXXXX| $FFDC
       .byte $FF ; |XXXXXXXX| $FFDD
       .byte $FF ; |XXXXXXXX| $FFDE
       .byte $FF ; |XXXXXXXX| $FFDF
       .byte $FF ; |XXXXXXXX| $FFE0
       .byte $FF ; |XXXXXXXX| $FFE1
       .byte $FF ; |XXXXXXXX| $FFE2
       .byte $FF ; |XXXXXXXX| $FFE3
       .byte $FF ; |XXXXXXXX| $FFE4
       .byte $FF ; |XXXXXXXX| $FFE5
       .byte $FF ; |XXXXXXXX| $FFE6
       .byte $FF ; |XXXXXXXX| $FFE7
       .byte $FF ; |XXXXXXXX| $FFE8
       .byte $FF ; |XXXXXXXX| $FFE9
       .byte $FF ; |XXXXXXXX| $FFEA
       .byte $FF ; |XXXXXXXX| $FFEB
       .byte $FF ; |XXXXXXXX| $FFEC
       .byte $FF ; |XXXXXXXX| $FFED
       .byte $FF ; |XXXXXXXX| $FFEE
       .byte $FF ; |XXXXXXXX| $FFEF
       .byte $FF ; |XXXXXXXX| $FFF0
       .byte $FF ; |XXXXXXXX| $FFF1
       .byte $FF ; |XXXXXXXX| $FFF2
       .byte $FF ; |XXXXXXXX| $FFF3
       .byte $FF ; |XXXXXXXX| $FFF4
       .byte $FF ; |XXXXXXXX| $FFF5
       .byte $FF ; |XXXXXXXX| $FFF6
       .byte $FF ; |XXXXXXXX| $FFF7
       .byte $FF ; |XXXXXXXX| $FFF8
       .byte $FF ; |XXXXXXXX| $FFF9

       .word START, START, START